// 1.11.4
/*global jQuery*/
(
  function($)
  {
    if (!$.pincette)
    {
      $.extend({pincette: {}});
    }

    $.pincette.util = {};
    $.pincette.util.dc = {};
    $.pincette.util.dom = {};
    $.pincette.util.jq = {};
    $.pincette.util.ui = {};
    $.pincette.util.url = {};



    var elementToLabelMap =
      {
        en:
          {
            dc_contributor: 'Contributor',
            dc_coverage: 'Coverage',
            dc_creator: 'Author',
            dc_date: 'Date',
            dc_description: 'Description',
            dc_format: 'Format',
            dc_identifier: 'Identifier',
            dc_language: 'Language',
            dc_publisher: 'Publisher',
            dc_relation: 'Relation',
            dc_rights: 'Rights',
            dc_source: 'Source',
            dc_subject: 'Subject',
            dc_title: 'Title',
            dc_type: 'Type'
          },
        fr:
          {
            dc_contributor: 'Contributeur',
            dc_coverage: 'Couverture',
            dc_creator: 'Auteur',
            dc_date: 'Date',
            dc_description: 'Description',
            dc_format: 'Format',
            dc_identifier: 'Identifiant',
            dc_language: 'Langue',
            dc_publisher: 'Editeur',
            dc_relation: 'Relation',
            dc_rights: 'Droits',
            dc_source: 'Source',
            dc_subject: 'Sujet',
            dc_title: 'Titre',
            dc_type: 'Type'
          },
        nl:
          {
            dc_contributor: 'Medewerker',
            dc_coverage: 'Dekking',
            dc_creator: 'Auteur',
            dc_date: 'Datum',
            dc_description: 'Omschrijving',
            dc_format: 'Formaat',
            dc_identifier: 'Referentienummer',
            dc_language: 'Taal',
            dc_publisher: 'Uitgever',
            dc_relation: 'Relatie',
            dc_rights: 'Rechten',
            dc_source: 'Bron',
            dc_subject: 'Onderwerp',
            dc_title: 'Titel',
            dc_type: 'Type'
          }
      };
    var labelToElementMap = {};
    var labelToTermMap = {};
    var termToLabelMap =
      {
        en:
          {
            dcterms_abstract: 'Abstract',
            dcterms_accessRights: 'Access Rights',
            dcterms_accrualMethod: 'Accrual Method',
            dcterms_accrualPeriodicity: 'Accrual Periodicity',
            dcterms_accrualPolicy: 'Accrual Policy',
            dcterms_alternative: 'Alternative Title',
            dcterms_audience: 'Audience',
            dcterms_available: 'Date Available',
            dcterms_bibliographicCitation: 'Bibliographic Citation',
            dcterms_conformsTo: 'Conforms To',
            dcterms_contributor: 'Contributor',
            dcterms_coverage: 'Coverage',
            dcterms_created: 'Date Created',
            dcterms_creator: 'Author',
            dcterms_date: 'Date',
            dcterms_dateAccepted: 'Date Accepted',
            dcterms_dateCopyrighted: 'Date Copyrighted',
            dcterms_dateSubmitted: 'Date Submitted',
            dcterms_description: 'Description',
            dcterms_educationLevel: 'Audience Education Level',
            dcterms_extent: 'Extent',
            dcterms_format: 'Format',
            dcterms_hasFormat: 'Has Format',
            dcterms_hasPart: 'Has Part',
            dcterms_hasVersion: 'Has Version',
            dcterms_identifier: 'Reference Number',
            dcterms_instructionalMethod: 'Instructional Method',
            dcterms_isFormatOf: 'Is Format Of',
            dcterms_isPartOf: 'Is Part Of',
            dcterms_isReferencedBy: 'Is Referenced By',
            dcterms_isReplacedBy: 'Is Replaced By',
            dcterms_isRequiredBy: 'Is Required By',
            dcterms_issued: 'Date Issued',
            dcterms_isVersionOf: 'Is Version Of',
            dcterms_language: 'Language',
            dcterms_license: 'License',
            dcterms_mediator: 'Mediator',
            dcterms_medium: 'Medium',
            dcterms_modified: 'Date Modified',
            dcterms_provenance: 'Provenance',
            dcterms_publisher: 'Publisher',
            dcterms_references: 'References',
            dcterms_relation: 'Relation',
            dcterms_replaces: 'Replaces',
            dcterms_requires: 'Requires',
            dcterms_rights: 'Rights',
            dcterms_rightsHolder: 'Rights Holder',
            dcterms_source: 'Source',
            dcterms_spatial: 'Spatial Coverage',
            dcterms_subject: 'Subject',
            dcterms_tableOfContents: 'Table Of Contents',
            dcterms_temporal: 'Temporal Coverage',
            dcterms_title: 'Title',
            dcterms_type: 'Type',
            dcterms_valid: 'Date Valid',
            re_assignedUser: 'Assigned User',
            re_comment: 'Comment',
            re_company: 'Company',
            re_dueDate: 'Due Date',
            re_keyword: 'Keyword',
            re_manager: 'Manager',
            re_status: 'Status',
            re_workflowStepId: 'Workflow Step ID'
          },
        fr:
          {
            dcterms_abstract: 'R\u00e9sum\u00e9',
            dcterms_accessRights: 'Droits d\'acc\u00e8s',
            dcterms_accrualMethod: 'M\u00e9thode d\'accumulation',
            dcterms_accrualPeriodicity: 'P\u00e9riodicit\u00e9 d\'exercice',
            dcterms_accrualPolicy: 'Politique d\'exercice',
            dcterms_alternative: 'Titre alternatif',
            dcterms_audience: 'Publique',
            dcterms_available: 'Date de disponibilit\u00e9',
            dcterms_bibliographicCitation: 'Citation bibliographique',
            dcterms_conformsTo: 'Conforme \u00e0',
            dcterms_contributor: 'Collaborateur',
            dcterms_coverage: 'Coverture',
            dcterms_created: 'Date de cr\u00e9ation',
            dcterms_creator: 'Auteur',
            dcterms_date: 'Date',
            dcterms_dateAccepted: 'Date d\'acceptation',
            dcterms_dateCopyrighted: 'Date de droits d\'auteur',
            dcterms_dateSubmitted: 'Date de soumission',
            dcterms_description: 'Description',
            dcterms_educationLevel: 'Niveau \u00e9ducatif du publique',
            dcterms_extent: 'Mesure',
            dcterms_format: 'Format',
            dcterms_hasFormat: 'A comme format',
            dcterms_hasPart: 'A comme partie',
            dcterms_hasVersion: 'A comme version',
            dcterms_identifier: 'Identifiant',
            dcterms_instructionalMethod: 'M\u00e9thode p\u00e9dagogique',
            dcterms_isFormatOf: 'Est format de',
            dcterms_isPartOf: 'Est partie de',
            dcterms_isReferencedBy: 'Est r\u00e9f\u00e9r\u00e9 par',
            dcterms_isReplacedBy: 'Est remplac\u00e9 par',
            dcterms_isRequiredBy: 'Est requis pour',
            dcterms_issued: 'Date d\'apparition',
            dcterms_isVersionOf: 'Est version de',
            dcterms_language: 'Langue',
            dcterms_license: 'Licence',
            dcterms_mediator: 'M\u00e9diateur',
            dcterms_medium: 'Medium',
            dcterms_modified: 'Date de modification',
            dcterms_provenance: 'Provenance',
            dcterms_publisher: 'Editeur',
            dcterms_references: 'R\u00e9f\u00e9r\u00e9nces',
            dcterms_relation: 'Relation',
            dcterms_replaces: 'Remplace',
            dcterms_requires: 'Exige',
            dcterms_rights: 'Droits',
            dcterms_rightsHolder: 'D\u00e9tenteur des droits',
            dcterms_source: 'Source',
            dcterms_spatial: 'Couverture spatiale',
            dcterms_subject: 'Sujet',
            dcterms_tableOfContents: 'Table des mati\u00e8res',
            dcterms_temporal: 'Couverture temporale',
            dcterms_title: 'Titre',
            dcterms_type: 'Type',
            dcterms_valid: 'Date de validit\u00e9',
            re_assignedUser: 'Utilisateur assign\u00e9',
            re_comment: 'Commentaire',
            re_company: 'Entreprise',
            re_dueDate: 'Date d\'\u00e9ch\u00e9ance',
            re_keyword: 'Mot cl\u00e9',
            re_manager: 'Gestionnaire',
            re_status: 'Status',
            re_workflowStepId: 'ID d\'\u00e9tappe workflow'
          },
        nl:
          {
            dcterms_abstract: 'Korte inhoud',
            dcterms_accessRights: 'Toegangsrechten',
            dcterms_accrualMethod: 'Groeimethode',
            dcterms_accrualPeriodicity: 'Groeifrequentie',
            dcterms_accrualPolicy: 'Groeipolitiek',
            dcterms_alternative: 'Alternatieve titel',
            dcterms_audience: 'Toehoorders',
            dcterms_available: 'Beschikbaarheidsdatum',
            dcterms_bibliographicCitation: 'Bibliografisch citaat',
            dcterms_conformsTo: 'Conform aan',
            dcterms_contributor: 'Medewerker',
            dcterms_coverage: 'Dekking',
            dcterms_created: 'Creatiedatum',
            dcterms_creator: 'Auteur',
            dcterms_date: 'Datum',
            dcterms_dateAccepted: 'Aanvaardingsdatum',
            dcterms_dateCopyrighted: 'Datum copyright',
            dcterms_dateSubmitted: 'Indieningsdatum',
            dcterms_description: 'Omschrijving',
            dcterms_educationLevel: 'Opleidingsniveau toehoorders',
            dcterms_extent: 'Omvang',
            dcterms_format: 'Formaat',
            dcterms_hasFormat: 'Heeft formaat',
            dcterms_hasPart: 'Heeft onderdeel',
            dcterms_hasVersion: 'Heeft versie',
            dcterms_identifier: 'Referentienummer',
            dcterms_instructionalMethod: 'Leermethode',
            dcterms_isFormatOf: 'Is formaat van',
            dcterms_isPartOf: 'Is deel van',
            dcterms_isReferencedBy: 'Wordt gerefereerd door',
            dcterms_isReplacedBy: 'Is vervangen door',
            dcterms_isRequiredBy: 'Is nodig voor',
            dcterms_issued: 'Verschijningsdatum',
            dcterms_isVersionOf: 'Is versie van',
            dcterms_language: 'Taal',
            dcterms_license: 'Licentie',
            dcterms_mediator: 'Bemiddelaar',
            dcterms_medium: 'Medium',
            dcterms_modified: 'Wijzigingsdatum',
            dcterms_provenance: 'Afkomst',
            dcterms_publisher: 'Uitgever',
            dcterms_references: 'Referenties',
            dcterms_relation: 'Relatie',
            dcterms_replaces: 'Vervangt',
            dcterms_requires: 'Heeft nodig',
            dcterms_rights: 'Rechten',
            dcterms_rightsHolder: 'Houder van de rechten',
            dcterms_source: 'Bron',
            dcterms_spatial: 'Ruimtelijke dekking',
            dcterms_subject: 'Onderwerp',
            dcterms_tableOfContents: 'Inhoudstafel',
            dcterms_temporal: 'Dekking in de tijd',
            dcterms_title: 'Titel',
            dcterms_type: 'Type',
            dcterms_valid: 'Geldigheidsdatum',
            re_assignedUser: 'Toegekende gebruiker',
            re_comment: 'Commentaar',
            re_company: 'Bedrijf',
            re_dueDate: 'Vervaldag',
            re_keyword: 'Trefwoord',
            re_manager: 'Manager',
            re_status: 'Status',
            re_workflowStepId: 'Workflow stap-ID'
          }
      };

    for (var i in elementToLabelMap)
    {
      if (elementToLabelMap.hasOwnProperty(i))
      {
        labelToElementMap[i] = {};

        for (var j1 in elementToLabelMap[i])
        {
          if (elementToLabelMap[i].hasOwnProperty(j1))
          {
            labelToElementMap[i][elementToLabelMap[i][j1]] = j1;
          }
        }
      }
    }

    for (i in termToLabelMap)
    {
      if (termToLabelMap.hasOwnProperty(i))
      {
        labelToTermMap[i] = {};

        for (var j2 in termToLabelMap[i])
        {
          if (termToLabelMap[i].hasOwnProperty(j2))
          {
            labelToTermMap[i][termToLabelMap[i][j2]] = j2;
          }
        }
      }
    }



    var languages =
      [
        'af', 'bs', 'ca', 'co', 'cs', 'cy', 'da', 'de', 'en', 'es', 'et', 'eu',
          'fy', 'fr', 'ga', 'gd', 'gl', 'hu', 'is', 'it', 'lb', 'lt', 'lv',
          'nl', 'no', 'pl', 'pt', 'ro', 'sk', 'sl', 'sv'
      ];

    var resources =
      {
        en:
          {
            'af': 'African',
            'bs': 'Bosnian',
            'ca': 'Catalan',
            'co': 'Corsican',
            'cs': 'Czech',
            'cy': 'Welsh',
            'da': 'Danish',
            'de': 'German',
            'en': 'English',
            'es': 'Spanish',
            'et': 'Estonian',
            'eu': 'Basque',
            'fy': 'Frisian',
            'fr': 'French',
            'ga': 'Irish Gaelic',
            'gd': 'Scottish Gaelic',
            'gl': 'Galician',
            'hu': 'Hungarian',
            'is': 'Icelandic',
            'it': 'Italian',
            'lb': 'Luxembourg',
            'lt': 'Lithuanian',
            'lv': 'Latvian',
            'nl': 'Dutch',
            'no': 'Norwegian',
            'pl': 'Polish',
            'pt': 'Portuguese',
            'ro': 'Romanian',
            'sk': 'Slovak',
            'sl': 'Slovenian',
            'sv': 'Swedish',
            'label-cancel': 'Cancel',
            'label-name': 'Name',
            'label-no': 'No',
            'label-ok': 'OK',
            'label-yes': 'Yes',
            'msg-confirm': 'Are you sure?'
          },
        fr:
          {
            'af': 'Africain',
            'bs': 'Bosniaque',
            'ca': 'Catalan',
            'co': 'Corse',
            'cs': 'Tch\u00e8que',
            'cy': 'Gallois',
            'da': 'Danois',
            'de': 'Allemand',
            'en': 'Anglais',
            'es': 'Espagnol',
            'et': 'Estonien',
            'eu': 'Basque',
            'fy': 'Frison',
            'fr': 'Fran\u00e7ais',
            'ga': 'Ga\u00e9lique irlandais',
            'gd': 'Ga\u00e9lique \u00e9cossais',
            'gl': 'Galicien',
            'hu': 'Hongrois',
            'is': 'Islandais',
            'it': 'Italienne',
            'lb': 'Luxembourg',
            'lt': 'Lituanie',
            'lv': 'Letton',
            'nl': 'N\u00e9erlandais',
            'no': 'Norv\u00e9gien',
            'pl': 'Polonaise',
            'pt': 'Portugais',
            'ro': 'Roumain',
            'sk': 'Slovaque',
            'sl': 'Slov\u00e8ne',
            'sv': 'Su\u00e9dois',
            'label-cancel': 'Annuler',
            'label-name': 'Nom',
            'label-no': 'Non',
            'label-ok': 'OK',
            'label-yes': 'Oui',
            'msg-confirm': 'Etes-vous certain?'
          },
        nl:
          {
            'af': 'Afrikaans',
            'bs': 'Bosnisch',
            'ca': 'Catalaans',
            'co': 'Corsicaans',
            'cs': 'Tsjechisch',
            'cy': 'Welsh',
            'da': 'Deens',
            'de': 'Duits',
            'en': 'Engels',
            'es': 'Spaans',
            'et': 'Ests',
            'eu': 'Baskisch',
            'fy': 'Fries',
            'fr': 'Frans',
            'ga': 'Iers-Gaelisch',
            'gd': 'Schots-Gaelisch',
            'gl': 'Galicisch',
            'hu': 'Hongaars',
            'is': 'Ijslands',
            'it': 'Italiaans',
            'lb': 'Luxemburgs',
            'lt': 'Litouws',
            'lv': 'Lets',
            'nl': 'Nederlands',
            'no': 'Noors',
            'pl': 'Pools',
            'pt': 'Portugees',
            'ro': 'Roemeens',
            'sk': 'Slovaaks',
            'sl': 'Sloveens',
            'sv': 'Zweeds',
            'label-cancel': 'Annuleer',
            'label-name': 'Naam',
            'label-no': 'Nee',
            'label-ok': 'OK',
            'label-yes': 'Ja',
            'msg-confirm': 'Bent u zeker?'
          }
      };



    var shortDateFormats =
      {
        bg: 'dd.mm.yy',
        br: 'm/d/yy',
        ca: 'dd/mm/yy',
        cs: 'd.m.y',
        da: 'dd/mm/yy',
        de: 'dd.mm.yy',
        el: 'd/m/yy',
        en: 'm/d/yy',
        'en-gb': 'dd/mm/yy',
        es: 'd/mm/yy',
        eu: 'yy-mm-dd',
        fi: 'd.m.yy',
        fr: 'dd/mm/yy',
        ga: 'dd/mm/yy',
        hu: 'y.mm.dd.',
        it: 'dd/mm/yy',
        mt: 'dd/mm/yy',
        'nl': 'd/m/yy',
        'nl-be': 'd/m/yy',
        'nl-nl': 'd-m-yy',
        no: 'dd.mm.yy',
        pl: 'dd.mm.yy',
        pt: 'dd/mm/yy',
        ro: 'dd.mm.yy',
        ru: 'dd.mm.yy',
        sk: 'd.m.yy',
        sl: 'd .mm. yy',
        sv: 'yy-mm-dd'
      };

    var timeFormats =
      {
        bg: 'HH:mm:ss',
        br: 'hh:mm:ss a.m.|p.m.',
        ca: 'HH:mm:ss',
        cs: 'HH:mm:ss',
        da: 'HH:mm:ss',
        de: 'HH:mm:ss',
        el: 'hh:mm:ss \u03c0.\u03bc.|\u03bc.\u03bc.',
        en: 'hh:mm:ss a.m.|p.m.',
        'en-gb': 'HH:mm:ss',
        eu: 'HH:mm:ss',
        fi: 'HH:mm:ss',
        fr: 'HH:mm:ss',
        ga: 'HH:mm:ss',
        hu: 'HH:mm:ss',
        it: 'HH:mm:ss',
        mt: 'HH:mm:ss',
        nl: 'HH:mm:ss',
        no: 'HH:mm:ss',
        pl: 'HH:mm:ss',
        pt: 'HH:mm:ss',
        ro: 'HH:mm:ss',
        ru: 'HH:mm:ss',
        sk: 'HH:mm:ss',
        sl: 'HH:mm:ss',
        sv: 'HH:mm:ss'
      };



    var mimeTypeExtensions =
      {
        'application/andrew-inset': 'ez',
        'application/atom+xml': 'atom',
        'application/cu-seeme': 'cu',
        'application/epub+zip': 'epub',
        'application/excel': 'xls',
        'application/javascript': 'js',
        'application/msword': 'doc',
        'application/pdf': 'pdf',
        'application/pgp-signature': 'pgp',
        'application/postscript': 'ps',
        'application/powerpoint': 'ppt',
        'application/rdf+xml': 'rdf',
        'application/rss+xml': 'rss',
        'application/rtf': 'rtf',
        'application/sgml': 'xgml',
        'application/smil+xml': 'smil',
        'application/vnd.framemaker': 'frm',
        'application/vnd.ms-excel': 'xls',
        'application/vnd.ms-excel.addin.macroEnabled.12': 'xlam',
        'application/vnd.ms-excel.sheet.binary.macroEnabled.12': 'xlsb',
        'application/vnd.ms-excel.sheet.macroEnabled.12': 'xlsm',
        'application/vnd.ms-excel.template': 'xlt',
        'application/vnd.ms-excel.template.macroEnabled.12': 'xltm',
        'application/vnd.ms-powerpoint': 'ppt',
        'application/vnd.ms-powerpoint.addin.macroEnabled.12': 'ppam',
        'application/vnd.ms-powerpoint.presentation.macroEnabled.12': 'pptm',
        'application/vnd.ms-powerpoint.slideshow': 'pps',
        'application/vnd.ms-powerpoint.slideshow.macroEnabled.12': 'ppsm',
        'application/vnd.ms-powerpoint.template': 'pot',
        'application/vnd.ms-powerpoint.template.macroEnabled.12': 'potm',
        'application/vnd.ms-project': 'mpp',
        'application/vnd.ms-word.document.macroEnabled.12': 'docm',
        'application/vnd.ms-word.template': 'dot',
        'application/vnd.ms-word.template.macroEnabled.12': 'dotm',
        'application/vnd.oasis.opendocument.chart': 'odc',
        'application/vnd.oasis.opendocument.chart-template': 'otc',
        'application/vnd.oasis.opendocument.formula': 'odf',
        'application/vnd.oasis.opendocument.graphics': 'odg',
        'application/vnd.oasis.opendocument.graphics-template': 'otg',
        'application/vnd.oasis.opendocument.image': 'odi',
        'application/vnd.oasis.opendocument.image-template': 'oti',
        'application/vnd.oasis.opendocument.presentation': 'odp',
        'application/vnd.oasis.opendocument.presentation-template': 'otp',
        'application/vnd.oasis.opendocument.spreadsheet': 'ods',
        'application/vnd.oasis.opendocument.spreadsheet-template': 'ots',
        'application/vnd.oasis.opendocument.text': 'odt',
        'application/vnd.oasis.opendocument.text-master': 'odm',
        'application/vnd.oasis.opendocument.text-template': 'ott',
        'application/vnd.openxmlformats-officedocument.presentationml.slideshow': 'ppsx',
        'application/vnd.openxmlformats-officedocument.presentationml.presentation': 'pptx',
        'application/vnd.openxmlformats-officedocument.presentationml.template': 'potx',
        'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': 'xlsx',
        'application/vnd.openxmlformats-officedocument.spreadsheetml.template': 'xltx',
        'application/vnd.openxmlformats-officedocument.wordprocessingml.document': 'docx',
        'application/vnd.openxmlformats-officedocument.wordprocessingml.template': 'dotx',
        'application/vnd.pincette.workflow+xml': 'pwfl',
        'application/vnd.visio': 'vsd',
        'application/vnd.wordperfect': 'wpd',
        'application/voicexml+xml': 'xml',
        'application/xhtml+xml': 'xhtml',
        'application/xml': 'xml',
        'application/xml-dtd': 'dtd',
        'application/xml-external-parsed-entity': 'ent',
        'application/java-archive': 'jar',
        'application/x-java-jnlp-file': 'jnlp',
        'application/x-javascript': 'js',
        'application/x-msaccess': 'mdb',
        'application/x-shockwave-flash': 'swf',
        'application/x-xmind': 'xmind',
        'application/zip': 'zip',
        'audio/basic': 'au',
        'audio/midi': 'midi',
        'audio/mp4': 'm4a',
        'audio/mpeg': 'mp3',
        'audio/mpeg4-generic': 'm4a',
        'audio/x-aiff': 'aif',
        'audio/x-mpegurl': 'm3u',
        'audio/x-pn-realaudio': 'ra',
        'audio/x-wav': 'wav',
        'image/bmp': 'bmp',
        'image/cgm': 'cgm',
        'image/g3fax': 'fax',
        'image/gif': 'gif',
        'image/ief': 'ief',
        'image/jp2': 'jp2',
        'image/jpeg': 'jpg',
        'image/png': 'png',
        'image/tiff': 'tiff',
        'image/vnd.adobe.photoshop': 'psd',
        'image/vnd.microsoft.icon': 'ico',
        'text/css': 'css',
        'text/csv': 'csv',
        'text/ecmascript': 'js',
        'text/html': 'html',
        'text/javascript': 'js',
        'text/php': 'php',
        'text/plain': 'txt',
        'text/richtext': 'rtx',
        'text/rtf': 'rtf',
        'text/sgml': 'sgml',
        'text/troff': 'troff',
        'text/xml': 'xml',
        'text/xml-external-parsed-entity': 'ent',
        'video/fli': 'fli',
        'video/gl': 'gl',
        'video/mp4': 'm4v',
        'video/mpeg': 'mpg',
        'video/quicktime': 'mov',
        'video/vnd.mpegurl': 'mxu',
        'video/vnd.rn-realvideo': 'rv',
        'video/x-dv': 'dv',
        'video/x-flv': 'flv',
        'video/x-m4v': 'm4v',
        'video/x-ms-wmv': 'wmv',
        'video/x-msvideo': 'avi',
        'video/x-sgi-movie': 'movie'
      };

    var extensionMimeTypes = reverseMap(mimeTypeExtensions);

    var mimeTypeLabelMap =
      {
        en:
          {
            'application/andrew-inset': 'Andrew inset',
            'application/atom+xml': 'News feed',
            'application/cu-seeme': 'CU-SeeMe',
            'application/ecmascript': 'Ecmascript',
            'application/epub+zip': 'EPub e-book',
            'application/excel': 'Excel',
            'application/javascript': 'JavaScript',
            'application/mpeg4-generic': 'MPEG4',
            'application/msword': 'Word',
            'application/octet-stream': 'Binary',
            'application/pdf': 'PDF',
            'application/pgp-signature': 'PGP-signature',
            'application/postscript': 'PostScript',
            'application/powerpoint': 'Powerpoint',
            'application/rdf+xml': 'RDF',
            'application/rss+xml': 'RSS feed',
            'application/rtf': 'Rich text',
            'application/sgml': 'SGML',
            'application/sgml-open-catalog': 'SGML catalog',
            'application/smil+xml': 'SMIL',
            'application/vnd.businessobjects': 'Business objects',
            'application/vnd.cinderella': 'Cinderella',
            'application/vnd.fdf': 'FDF',
            'application/vnd.framemaker': 'Framemaker',
            'application/vnd.ms-excel': 'Excel',
            'application/vnd.ms-excel.addin.macroEnabled.12': 'Excel add-in',
            'application/vnd.ms-excel.sheet.binary.macroEnabled.12': 'Excel',
            'application/vnd.ms-excel.sheet.macroEnabled.12': 'Excel',
            'application/vnd.ms-excel.template': 'Excel template',
            'application/vnd.ms-excel.template.macroEnabled.12': 'Excel template',
            'application/vnd.ms-htmlhelp': 'MS HTML help',
            'application/vnd.ms-powerpoint': 'Powerpoint',
            'application/vnd.ms-powerpoint.addin.macroEnabled.12': 'Powerpoint add-in',
            'application/vnd.ms-powerpoint.presentation.macroEnabled.12': 'Powerpoint',
            'application/vnd.ms-powerpoint.slideshow': 'Powerpoint slideshow',
            'application/vnd.ms-powerpoint.slideshow.macroEnabled.12': 'Powerpoint slideshow',
            'application/vnd.ms-powerpoint.template': 'Powerpoint template',
            'application/vnd.ms-powerpoint.template.macroEnabled.12': 'Powerpoint template',
            'application/vnd.ms-project': 'MS Project',
            'application/vnd.ms-word.document.macroEnabled.12': 'Word',
            'application/vnd.ms-word.template': 'Word template',
            'application/vnd.ms-word.template.macroEnabled.12': 'Word template',
            'application/vnd.ms-works': 'MS Works',
            'application/vnd.oasis.opendocument.chart': 'ODF chart',
            'application/vnd.oasis.opendocument.chart-template': 'ODF chart template',
            'application/vnd.oasis.opendocument.formula': 'ODF formula',
            'application/vnd.oasis.opendocument.formula-template': 'ODF formula template',
            'application/vnd.oasis.opendocument.graphics': 'ODF graphics',
            'application/vnd.oasis.opendocument.graphics-template': 'ODF graphics template',
            'application/vnd.oasis.opendocument.image': 'ODF image',
            'application/vnd.oasis.opendocument.image-template': 'ODF image template',
            'application/vnd.oasis.opendocument.presentation': 'ODF presentation',
            'application/vnd.oasis.opendocument.presentation-template': 'ODF presentation template',
            'application/vnd.oasis.opendocument.spreadsheet': 'ODF spreadsheet',
            'application/vnd.oasis.opendocument.spreadsheet-template': 'ODF spreadsheet template',
            'application/vnd.oasis.opendocument.text': 'ODF text',
            'application/vnd.oasis.opendocument.text-master': 'ODF text master',
            'application/vnd.oasis.opendocument.text-template': 'ODF text template',
            'application/vnd.openxmlformats-officedocument.presentationml.slideshow': 'Powerpoint 2007 slideshow',
            'application/vnd.openxmlformats-officedocument.presentationml.presentation': 'Powerpoint 2007',
            'application/vnd.openxmlformats-officedocument.presentationml.template': 'Powerpoint 2007 template',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': 'Excel 2007',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.template': 'Excel 2007 template',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.document': 'Word 2007',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.template': 'Word template 2007',
            'application/vnd.palm': 'Palm',
            'application/vnd.pincette.workflow+xml': 'Pincette workflow',
            'application/vnd.visio': 'Visio',
            'application/vnd.wordperfect': 'Wordperfect',
            'application/voicexml+xml': 'Voice XML',
            'application/xhtml+xml': 'XHTML',
            'application/xml': 'XML',
            'application/xml-dtd': 'DTD',
            'application/xml-external-parsed-entity': 'Parsed entity',
            'application/java-archive': 'Java archive',
            'application/x-java-jnlp-file': 'JNLP',
            'application/x-javascript': 'JavaScript',
            'application/x-msaccess': 'Access',
            'application/x-shockwave-flash': 'Shockwave Flash',
            'application/x-xmind': 'XMind',
            'application/zip': 'ZIP',
            'audio/basic': 'Basic audio',
            'audio/midi': 'MIDI',
            'audio/mp4': 'MP4 audio',
            'audio/mpeg': 'MPEG audio',
            'audio/mpeg4-generic': 'MPEG4 audio',
            'audio/x-aiff': 'AIFF audio',
            'audio/x-mpegurl': 'MPEG audio URL',
            'audio/x-pn-realaudio': 'REAL audio',
            'audio/x-wav': 'WAVE audio',
            'image/bmp': 'BMP',
            'image/cgm': 'CGM',
            'image/g3fax': 'Fax',
            'image/gif': 'GIF',
            'image/ief': 'IEF',
            'image/jp2': 'JP2',
            'image/jpeg': 'JPEG',
            'image/png': 'PNG',
            'image/tiff': 'TIFF',
            'image/vnd.adobe.photoshop': 'Photoshop',
            'image/vnd.microsoft.icon': 'MS icon',
            'text/calendar': 'Calendar',
            'text/css': 'CSS',
            'text/csv': 'CSV',
            'text/directory': 'Directory',
            'text/ecmascript': 'Ecmascript',
            'text/enriched': 'Enriched text',
            'text/html': 'HTML',
            'text/javascript': 'JavaScript',
            'text/php': 'PHP',
            'text/plain': 'Text',
            'text/richtext': 'Rich text',
            'text/rtf': 'Rich text',
            'text/sgml': 'SGML',
            'text/troff': 'Troff',
            'text/xml': 'XML',
            'text/xml-external-parsed-entity': 'Parsed entity',
            'video/JPEG': 'JPEG video',
            'video/fli': 'FLI video',
            'video/gl': 'GL video',
            'video/mp4': 'MP4 video',
            'video/mpeg': 'MPEG video',
            'video/mpeg4-generic': 'MPEG4 video',
            'video/quicktime': 'Quicktime video',
            'video/raw': 'Raw video',
            'video/vnd.mpegurl': 'MPEG video URL',
            'video/vnd.rn-realvideo': 'Real video',
            'video/x-dv': 'DV video',
            'video/x-flv': 'Flash video',
            'video/x-m4v': 'Apple video',
            'video/x-ms-wmv': 'Windows media video',
            'video/x-msvideo': 'AVI video',
            'video/x-sgi-movie': 'SGI movie'
          },
        fr:
          {
            'application/andrew-inset': 'Andrew inset',
            'application/atom+xml': 'News feed',
            'application/cu-seeme': 'CU-SeeMe',
            'application/ecmascript': 'Ecmascript',
            'application/epub+zip': 'EPub e-book',
            'application/excel': 'Excel',
            'application/javascript': 'JavaScript',
            'application/mpeg4-generic': 'MPEG4',
            'application/msword': 'Word',
            'application/octet-stream': 'Binary',
            'application/pdf': 'PDF',
            'application/pgp-signature': 'PGP-signature',
            'application/postscript': 'PostScript',
            'application/powerpoint': 'Powerpoint',
            'application/rdf+xml': 'RDF',
            'application/rss+xml': 'RSS feed',
            'application/rtf': 'Rich text',
            'application/sgml': 'SGML',
            'application/sgml-open-catalog': 'SGML catalog',
            'application/smil+xml': 'SMIL',
            'application/vnd.businessobjects': 'Business objects',
            'application/vnd.cinderella': 'Cinderella',
            'application/vnd.fdf': 'FDF',
            'application/vnd.framemaker': 'Framemaker',
            'application/vnd.ms-excel': 'Excel',
            'application/vnd.ms-excel.addin.macroEnabled.12': 'Excel add-in',
            'application/vnd.ms-excel.sheet.binary.macroEnabled.12': 'Excel',
            'application/vnd.ms-excel.sheet.macroEnabled.12': 'Excel',
            'application/vnd.ms-excel.template': 'Excel template',
            'application/vnd.ms-excel.template.macroEnabled.12': 'Excel template',
            'application/vnd.ms-htmlhelp': 'MS HTML help',
            'application/vnd.ms-powerpoint': 'Powerpoint',
            'application/vnd.ms-powerpoint.addin.macroEnabled.12': 'Powerpoint add-in',
            'application/vnd.ms-powerpoint.presentation.macroEnabled.12': 'Powerpoint',
            'application/vnd.ms-powerpoint.slideshow': 'Powerpoint slideshow',
            'application/vnd.ms-powerpoint.slideshow.macroEnabled.12': 'Powerpoint slideshow',
            'application/vnd.ms-powerpoint.template': 'Powerpoint template',
            'application/vnd.ms-powerpoint.template.macroEnabled.12': 'Powerpoint template',
            'application/vnd.ms-project': 'MS Project',
            'application/vnd.ms-word.document.macroEnabled.12': 'Word',
            'application/vnd.ms-word.template': 'Word template',
            'application/vnd.ms-word.template.macroEnabled.12': 'Word template',
            'application/vnd.ms-works': 'MS Works',
            'application/vnd.oasis.opendocument.chart': 'ODF chart',
            'application/vnd.oasis.opendocument.chart-template': 'ODF chart template',
            'application/vnd.oasis.opendocument.formula': 'ODF formula',
            'application/vnd.oasis.opendocument.formula-template': 'ODF formula template',
            'application/vnd.oasis.opendocument.graphics': 'ODF graphics',
            'application/vnd.oasis.opendocument.graphics-template': 'ODF graphics template',
            'application/vnd.oasis.opendocument.image': 'ODF image',
            'application/vnd.oasis.opendocument.image-template': 'ODF image template',
            'application/vnd.oasis.opendocument.presentation': 'ODF presentation',
            'application/vnd.oasis.opendocument.presentation-template': 'ODF presentation template',
            'application/vnd.oasis.opendocument.spreadsheet': 'ODF spreadsheet',
            'application/vnd.oasis.opendocument.spreadsheet-template': 'ODF spreadsheet template',
            'application/vnd.oasis.opendocument.text': 'ODF text',
            'application/vnd.oasis.opendocument.text-master': 'ODF text master',
            'application/vnd.oasis.opendocument.text-template': 'ODF text template',
            'application/vnd.openxmlformats-officedocument.presentationml.slideshow': 'Powerpoint 2007 slideshow',
            'application/vnd.openxmlformats-officedocument.presentationml.presentation': 'Powerpoint 2007',
            'application/vnd.openxmlformats-officedocument.presentationml.template': 'Powerpoint 2007 template',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': 'Excel 2007',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.template': 'Excel 2007 template',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.document': 'Word 2007',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.template': 'Word template 2007',
            'application/vnd.palm': 'Palm',
            'application/vnd.pincette.workflow+xml': 'Pincette workflow',
            'application/vnd.visio': 'Visio',
            'application/vnd.wordperfect': 'Wordperfect',
            'application/voicexml+xml': 'Voice XML',
            'application/xhtml+xml': 'XHTML',
            'application/xml': 'XML',
            'application/xml-dtd': 'DTD',
            'application/xml-external-parsed-entity': 'Parsed entity',
            'application/java-archive': 'Java archive',
            'application/x-java-jnlp-file': 'JNLP',
            'application/x-javascript': 'JavaScript',
            'application/x-msaccess': 'Access',
            'application/x-shockwave-flash': 'Shockwave Flash',
            'application/x-xmind': 'XMind',
            'application/zip': 'ZIP',
            'audio/basic': 'Basic audio',
            'audio/midi': 'MIDI',
            'audio/mp4': 'MP4 audio',
            'audio/mpeg': 'MPEG audio',
            'audio/mpeg4-generic': 'MPEG4 audio',
            'audio/x-aiff': 'AIFF audio',
            'audio/x-mpegurl': 'MPEG audio URL',
            'audio/x-pn-realaudio': 'REAL audio',
            'audio/x-wav': 'WAVE audio',
            'image/bmp': 'BMP',
            'image/cgm': 'CGM',
            'image/g3fax': 'Fax',
            'image/gif': 'GIF',
            'image/ief': 'IEF',
            'image/jp2': 'JP2',
            'image/jpeg': 'JPEG',
            'image/png': 'PNG',
            'image/tiff': 'TIFF',
            'image/vnd.adobe.photoshop': 'Photoshop',
            'image/vnd.microsoft.icon': 'MS icon',
            'text/calendar': 'Calendar',
            'text/css': 'CSS',
            'text/csv': 'CSV',
            'text/directory': 'Directory',
            'text/ecmascript': 'Ecmascript',
            'text/enriched': 'Enriched text',
            'text/html': 'HTML',
            'text/javascript': 'JavaScript',
            'text/php': 'PHP',
            'text/plain': 'Text',
            'text/richtext': 'Rich text',
            'text/rtf': 'Rich text',
            'text/sgml': 'SGML',
            'text/troff': 'Troff',
            'text/xml': 'XML',
            'text/xml-external-parsed-entity': 'Parsed entity',
            'video/JPEG': 'JPEG video',
            'video/fli': 'FLI video',
            'video/gl': 'GL video',
            'video/mp4': 'MP4 video',
            'video/mpeg': 'MPEG video',
            'video/mpeg4-generic': 'MPEG4 video',
            'video/quicktime': 'Quicktime video',
            'video/raw': 'Raw video',
            'video/vnd.mpegurl': 'MPEG video URL',
            'video/vnd.rn-realvideo': 'Real video',
            'video/x-dv': 'DV video',
            'video/x-flv': 'Flash video',
            'video/x-m4v': 'Apple video',
            'video/x-ms-wmv': 'Windows media video',
            'video/x-msvideo': 'AVI video',
            'video/x-sgi-movie': 'SGI movie'
          },
        nl:
          {
            'application/andrew-inset': 'Andrew inset',
            'application/atom+xml': 'Nieuwslijn',
            'application/cu-seeme': 'CU-SeeMe',
            'application/ecmascript': 'Ecmascript',
            'application/epub+zip': 'EPub e-book',
            'application/excel': 'Excel',
            'application/javascript': 'JavaScript',
            'application/mpeg4-generic': 'MPEG4',
            'application/msword': 'Word',
            'application/octet-stream': 'Binair',
            'application/pdf': 'PDF',
            'application/pgp-signature': 'PGP-handtekening',
            'application/postscript': 'PostScript',
            'application/powerpoint': 'Powerpoint',
            'application/rdf+xml': 'RDF',
            'application/rss+xml': 'RSS feed',
            'application/rtf': 'Rich text',
            'application/sgml': 'SGML',
            'application/sgml-open-catalog': 'SGML cataloog',
            'application/smil+xml': 'SMIL',
            'application/vnd.businessobjects': 'Business objects',
            'application/vnd.cinderella': 'Cinderella',
            'application/vnd.fdf': 'FDF',
            'application/vnd.framemaker': 'Framemaker',
            'application/vnd.ms-excel': 'Excel',
            'application/vnd.ms-excel.addin.macroEnabled.12': 'Excel add-in',
            'application/vnd.ms-excel.sheet.binary.macroEnabled.12': 'Excel',
            'application/vnd.ms-excel.sheet.macroEnabled.12': 'Excel',
            'application/vnd.ms-excel.template': 'Excel template',
            'application/vnd.ms-excel.template.macroEnabled.12': 'Excel template',
            'application/vnd.ms-htmlhelp': 'MS HTML help',
            'application/vnd.ms-powerpoint': 'Powerpoint',
            'application/vnd.ms-powerpoint.addin.macroEnabled.12': 'Powerpoint add-in',
            'application/vnd.ms-powerpoint.presentation.macroEnabled.12': 'Powerpoint',
            'application/vnd.ms-powerpoint.slideshow': 'Powerpoint slideshow',
            'application/vnd.ms-powerpoint.slideshow.macroEnabled.12': 'Powerpoint slideshow',
            'application/vnd.ms-powerpoint.template': 'Powerpoint template',
            'application/vnd.ms-powerpoint.template.macroEnabled.12': 'Powerpoint template',
            'application/vnd.ms-project': 'MS Project',
            'application/vnd.ms-word.document.macroEnabled.12': 'Word',
            'application/vnd.ms-word.template': 'Word template',
            'application/vnd.ms-word.template.macroEnabled.12': 'Word template',
            'application/vnd.ms-works': 'MS Works',
            'application/vnd.oasis.opendocument.chart': 'ODF chart',
            'application/vnd.oasis.opendocument.chart-template': 'ODF chart template',
            'application/vnd.oasis.opendocument.formula': 'ODF formula',
            'application/vnd.oasis.opendocument.formula-template': 'ODF formula template',
            'application/vnd.oasis.opendocument.graphics': 'ODF graphics',
            'application/vnd.oasis.opendocument.graphics-template': 'ODF graphics template',
            'application/vnd.oasis.opendocument.image': 'ODF image',
            'application/vnd.oasis.opendocument.image-template': 'ODF image template',
            'application/vnd.oasis.opendocument.presentation': 'ODF presentatie',
            'application/vnd.oasis.opendocument.presentation-template': 'ODF presentatie template',
            'application/vnd.oasis.opendocument.spreadsheet': 'ODF rekenblad',
            'application/vnd.oasis.opendocument.spreadsheet-template': 'ODF rekenblad template',
            'application/vnd.oasis.opendocument.text': 'ODF tekst',
            'application/vnd.oasis.opendocument.text-master': 'ODF tekst master',
            'application/vnd.oasis.opendocument.text-template': 'ODF tekst template',
            'application/vnd.openxmlformats-officedocument.presentationml.slideshow': 'Powerpoint 2007 slideshow',
            'application/vnd.openxmlformats-officedocument.presentationml.presentation': 'Powerpoint 2007',
            'application/vnd.openxmlformats-officedocument.presentationml.template': 'Powerpoint 2007 template',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': 'Excel 2007',
            'application/vnd.openxmlformats-officedocument.spreadsheetml.template': 'Excel 2007 template',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.document': 'Word 2007',
            'application/vnd.openxmlformats-officedocument.wordprocessingml.template': 'Word 2007 template',
            'application/vnd.palm': 'Palm',
            'application/vnd.pincette.workflow+xml': 'Pincette workflow',
            'application/vnd.visio': 'Visio',
            'application/vnd.wordperfect': 'Wordperfect',
            'application/voicexml+xml': 'Voice XML',
            'application/xhtml+xml': 'XHTML',
            'application/xml': 'XML',
            'application/xml-dtd': 'DTD',
            'application/xml-external-parsed-entity': 'Parsed entity',
            'application/java-archive': 'Java archive',
            'application/x-java-jnlp-file': 'JNLP',
            'application/x-javascript': 'JavaScript',
            'application/x-msaccess': 'Access',
            'application/x-shockwave-flash': 'Shockwave Flash',
            'application/x-xmind': 'XMind',
            'application/zip': 'ZIP',
            'audio/basic': 'Basic audio',
            'audio/midi': 'MIDI',
            'audio/mp4': 'MP4 audio',
            'audio/mpeg': 'MPEG audio',
            'audio/mpeg4-generic': 'MPEG4 audio',
            'audio/x-aiff': 'AIFF audio',
            'audio/x-mpegurl': 'MPEG audio URL',
            'audio/x-pn-realaudio': 'REAL audio',
            'audio/x-wav': 'WAVE audio',
            'image/bmp': 'BMP',
            'image/cgm': 'CGM',
            'image/g3fax': 'Fax',
            'image/gif': 'GIF',
            'image/ief': 'IEF',
            'image/jp2': 'JP2',
            'image/jpeg': 'JPEG',
            'image/png': 'PNG',
            'image/tiff': 'TIFF',
            'image/vnd.adobe.photoshop': 'Photoshop',
            'image/vnd.microsoft.icon': 'MS icoon',
            'text/calendar': 'Calender',
            'text/css': 'CSS',
            'text/csv': 'CSV',
            'text/directory': 'Directory',
            'text/ecmascript': 'Ecmascript',
            'text/enriched': 'Enriched text',
            'text/html': 'HTML',
            'text/javascript': 'JavaScript',
            'text/php': 'PHP',
            'text/plain': 'Tekst',
            'text/richtext': 'Rich text',
            'text/rtf': 'Rich text',
            'text/sgml': 'SGML',
            'text/troff': 'Troff',
            'text/xml': 'XML',
            'text/xml-external-parsed-entity': 'Parsed entity',
            'video/JPEG': 'JPEG video',
            'video/fli': 'FLI video',
            'video/gl': 'GL video',
            'video/mp4': 'MP4 video',
            'video/mpeg': 'MPEG video',
            'video/mpeg4-generic': 'MPEG4 video',
            'video/quicktime': 'Quicktime video',
            'video/raw': 'Raw video',
            'video/vnd.mpegurl': 'MPEG video URL',
            'video/vnd.rn-realvideo': 'Real video',
            'video/x-dv': 'DV video',
            'video/x-flv': 'Flash video',
            'video/x-m4v': 'Apple video',
            'video/x-ms-wmv': 'Windows media video',
            'video/x-msvideo': 'AVI video',
            'video/x-sgi-movie': 'SGI film'
          }
      };



    var emailPattern = /^[^@]+@[^@\.]+\.[^@]+$/;
    var floatPattern = /^(-|\+)?[0-9]+(\.[0-9]+)?$/;
    var indexedMonths =
      {
        'Jan': 0, 'Feb': 1, 'Mar': 2, 'Apr': 3, 'May': 4, 'Jun': 5, 'Jul': 6,
          'Aug': 7, 'Sep': 8, 'Oct': 9, 'Nov': 10, 'Dec': 11
      };
    var intPattern = /^(-|\\+)?[0-9]+$/;
    var mobileLargePattern = /.*(iPad;|Android|BlackBerry).*/;
    var mobileSmallPattern =
      /.*(iPhone;|iPod;|Android.*Mobile|BlackBerry.*Mobile|Opera Mobi|Opera Mini).*/;
    var month = '(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)';
    var poppedUp;
    var poppedUpTrigger;
    var time = '([0-9]{2}):([0-9]{2}):([0-9]{2})';
    var timeZoneOffset = '(GMT|(\\+|-)([0-9]{2})([0-9]{2}))';
    var wkday = '(Mon|Tue|Wed|Thu|Fri|Sat|Sun)';
    var weekday = '(Monday|Tuesday|Wednesday|Thursday|Friday|Saturday|Sunday)';
    var asctimeDatePattern =
      new RegExp
      (
        '^' + wkday + ' ' + month + ' ([0-9]{2}| [0-9]) ' + time +
          ' ([0-9]{4})' + '$'
      );
    var rfc1123DatePattern =
      new RegExp
      (
        '^' + wkday + ', ([0-9]{2}) ' + month + ' ([0-9]{4}) ' + time + ' ' +
          timeZoneOffset + '$'
      );
    var rfc850DatePattern =
      new RegExp
      (
        '^' + weekday + ', ([0-9]{2})-' + month + '-([0-9]{2}) ' + time + ' ' +
          timeZoneOffset + '$'
      );
    var timestampPattern =
      /^([0-9]{4})(-([0-9]{2})(-([0-9]{2})(T([0-9]{2}):([0-9]{2})(:([0-9]{2})(\.([0-9]+))?)?(Z|((-|\+)([0-9]{2}):?([0-9]{2})))?)?)?)?$/;
    var urlPattern =
      /^([^:]+):\/\/((([^@\/]*)@)?([^:\/]+)(:[0-9]*)?)?(\/[^\?#]*)?(\?([^#]*))?(#(.*))?$/;



    function addBoxMenuItemEvent(element, item)
    {
      element.click
      (
        function(e)
        {
          element.data('pincette-box-menu-close')();

          if (item.action)
          {
            item.action(element);
          }
        }
      );
    }



    function addMenuItemEvent(element, item)
    {
      element.click
      (
        function(e)
        {
          e.stopPropagation();
          element.parent().trigger('blur');

          if (item.action)
          {
            item.action(element);
          }
        }
      );
    }



    function dateFormatToPattern(format)
    {
      var result =
        format.replace('.', '\\.').replace(' ', ' +').
          replace(/dd/, '([0-9]{2})').
          replace(/d/, '([0-9]{1,2})').
          replace(/mm/, '([0-9]{2})').
          replace(/m/, '([0-9]{1,2})').
          replace(/yy/, '([0-9]{4})').
          replace(/y/, '([0-9]{2})');

      return result;
    }



    function elementSelector(node)
    {
      var result = node.nodeType == 1;

      return result;
    }



    function elementToValue(element)
    {
      if ($.pincette.util.dom.selectElements(element).length > 0)
      {
        return $.pincette.util.dom.toJson(element);
      }

      var text = $.pincette.util.dom.getText(element);

      if (text.length === 0)
      {
        return true;
      }

      if ($.pincette.util.isInteger(text))
      {
        return parseInt(text, 10);
      }

      if ($.pincette.util.isFloat(text))
      {
        return parseFloat(text);
      }

      var date = $.pincette.util.parseISO8601(text);

      if (date !== null)
      {
        return date;
      }

      return text;
    }



    function getBracedValues(s)
    {
      var position = 0;
      var result = [];

      for (var i = s.indexOf('('); i != -1; i = s.indexOf('(', position))
      {
        var j = s.indexOf(')', i + 1);

        if (j == -1) // Syntax error.
        {
          return null;
        }

        result.push(s.substring(i + 1, j));
        position = j + 1;
      }

      return result;
    }



    function getDate(initialValue, element, yearFrom, yearTo, result)
    {
      function reloadDay()
      {
        result.day.empty();

        var selected = result.month.val();
        var end =
          selected == '2' && leapYear ?
            29 :
            (
              selected == '2' && !leapYear ?
                28 :
                (
                  selected == '4' || selected == '6' || selected == '9' ||
                    selected == '11' ?
                    30 : 31
                )
            );

        for (var i = 1; i <= end; ++i)
        {
          var option = $('<option></option>');

          option.attr('label', i);
          option.attr('value', i);
          option.text(i);
          result.day.append(option);
        }
      }

      var leapYear = false;

      result.day = $('select[name="day"]', element);
      result.month = $('select[name="month"]', element);
      result.year = $('select[name="year"]', element);

      result.year.empty();

      if (!yearFrom)
      {
        yearFrom = 1950;
      }

      if (!yearTo)
      {
        yearTo = 2050;
      }

      for (var i = yearFrom; i <= yearTo; ++i)
      {
        var option1 = $('<option></option>');

        option1.attr('label', i);
        option1.attr('value', i);
        option1.text(i);
        result.year.append(option1);
      }

      result.year.change
      (
        function()
        {
          var selectedYear = Number(result.year.val());
          var isLeapYear = selectedYear % 4 === 0 && selectedYear % 400 !== 0;

          if (isLeapYear != leapYear)
          {
            leapYear = isLeapYear;

            if (result.month.val() == '2')
            {
              reloadDay();
            }
          }
        }
      );

      result.month.empty();

      for (i = 1; i <= 12; ++i)
      {
        var option2  = $('<option></option>');

        option2.attr('label', i);
        option2.attr('value', i);
        option2.text(i);
        result.month.append(option2);
      }

      result.month.change(reloadDay);
      reloadDay();

      if (!initialValue)
      {
        initialValue = new Date();
      }

      result.year.val(initialValue.getFullYear());
      result.month.val(initialValue.getMonth() + 1);
      result.day.val(initialValue.getDate());
    }



    function getTimeZoneOffset(sign, hours, minutes)
    {
      var result =
        (sign == '-' ? 1 : -1) * hours * 60 * 60 * 1000 +
          (sign == '-' ? 1 : -1) * minutes * 60 * 1000;

      return result;
    }



    function nameSelector(node, name)
    {
      var result =
        !name || (!name.namespaceURI && !name.localName) ||
          $.pincette.util.dom.hasName(node, name.namespaceURI, name.localName);

      return result;
    }



    function parseAsctimeDate(matches)
    {
      var millis =
        Date.UTC
        (
          Number(matches[7]),
          indexedMonths[matches[2]],
          Number(matches[3]),
          Number(matches[4]),
          Number(matches[5]),
          Number(matches[6])
        );

      return new Date(millis);
    }



    function parseRfc1123Date(matches)
    {
      var millis =
        Date.UTC
        (
          Number(matches[4]),
          indexedMonths[matches[3]],
          Number(matches[2]),
          Number(matches[5]),
          Number(matches[6]),
          Number(matches[7])
        );

      if (matches[8] != 'GMT')
      {
        millis +=
          getTimeZoneOffset
          (
            Number(matches[9]),
            Number(matches[10]),
            Number(matches[11])
          );
      }

      return new Date(millis);
    }



    function parseRfc850Date(matches)
    {
      var millis =
        Date.UTC
        (
          Number(matches[4]),
          Number(matches[3]),
          Number(matches[2]),
          Number(matches[5]),
          Number(matches[6]),
          Number(matches[7])
        );

      if (matches[8] != 'GMT')
      {
        millis +=
          getTimeZoneOffset
          (
            Number(matches[9]),
            Number(matches[10]),
            Number(matches[11])
          );
      }

      return new Date(millis);
    }



    function replaceParameters(s, data, open, close)
    {
      var position = 0;
      var result = '';

      for
      (
        var i = s.indexOf('$' + open);
        i != -1;
        i = s.indexOf('$' + open, position)
      )
      {
        var	j = s.indexOf(close, i + 2);

        if (j == -1) // Syntax error.
        {
          return s;
        }

        var colon = s.indexOf(':-', i + 2);
        var defaultValue;
        var value;

        if (colon != -1 && colon < j)
        {
          value = data[s.substring(i + 2, colon).trim()];
          defaultValue = s.substring(colon + 2, j).trim();

          if (defaultValue.indexOf('$') === 0)
          {
            defaultValue =
              replaceParameters
              (
                '$' + open + defaultValue.substring(1) + close,
                data,
                open,
                close
              );
          }
        }
        else
        {
          var question = s.indexOf('?', i + 2);

          if (question != -1 && question < j)
          {
            var values = getBracedValues(s.substring(question + 1, j));

            if (!values || values.length != 2)
            {
              return s;
            }

            value =
              data[s.substring(i + 2, question).trim()] ? values[0] : values[1];
            defaultValue = '';
          }
          else
          {
            value = data[s.substring(i + 2, j).trim()];
            defaultValue = '';
          }
        }

        try
        {
          result +=
            s.substring(position, i) +
              (value ? decodeURI(value) : defaultValue);
        }

        catch (e)
        {
          // Not a URI.

          result += s.substring(position, i) + (value ? value : defaultValue);
        }

        position = j + 1;
      }

      if (position < s.length)
      {
        result += s.substring(position);
      }

      return result;
    }



    function reverseMap(map)
    {
      var result = {};

      for (var key in map)
      {
        if (map.hasOwnProperty(key))
        {
          result[map[key]] = key;
        }
      }

      return result;
    }



    function selectPath(node, path, position, result)
    {
      var children =
        $.pincette.util.dom.selectElements
        (
          node,
          path[position].localName,
          path[position].namespaceURI
        );

      for (var i = 0; i < children.length; ++i)
      {
        if (position < path.length - 1)
        {
          selectPath(children[i], path, position + 1, result);
        }
        else
        {
          result[result.length] = children[i];
        }
      }
    }



    function timeFormatToPattern(format)
    {
      var result =
        format.replace(' ', ' +').
          replace(/a\.m\./, '(a\\.?m\\.?)').
          replace(/p\.m\./, '(p\\.?m\\.?)').
          replace(/\u03c0\.\u03bc\./, '(\u03c0\\.?\u03bc\\.?)').
          replace(/\u03bc\.\u03bc\./, '(\u03bc\\.?\u03bc\\.?)').
          replace(/HH/, '([0-9]{2})').
          replace(/hh/, '([0-9]{2})').
          replace(/mm/, '([0-9]{2})').
          replace(/ss/, '([0-9]{2})');

      return result;
    }



    function totalContentsHeight(element)
    {
      var bottom = -1;
      var top = -1;

      element.children().each
      (
        function()
        {
          var offset = $(this).offset();

          if (top == -1 || offset.top < top)
          {
            top = offset.top;
          }

          if (bottom == -1 || offset.top + $(this).height() > bottom)
          {
            bottom = offset.top + $(this).height();
          }
        }
      );

      return bottom != -1 && top != -1 ? (bottom - top) : 0;
    }



    $.pincette.util.addWrapPoints = function(s)
    {
      var result = s.replace(/[\/\-_\.]/g, '$&\u200b');

      return result;
    };



    $.pincette.util.applyChanges = function(array, changes)
    {
      var result = [];

      for (var i = 0; i < array.length; ++i)
      {
        var found1 = false;

        for (var j1 = 0; j1 < changes.deleted.length && !found1; ++j1)
        {
          if ($.pincette.util.valuesEqual(array[i], changes.deleted[j1]))
          {
            found1 = true;
          }
        }

        if (!found1)
        {
          result.push(array[i]);
        }
      }

      for (i = 0; i < changes.added.length; ++i)
      {
        var found2 = false;

        for (var j2 = 0; j2 < result.length && !found2; ++j2)
        {
          if ($.pincette.util.valuesEqual(changes.added[i], result[j2]))
          {
            found2 = true;
          }
        }

        if (!found2)
        {
          result.push(changes.added[i]);
        }
      }

      return result;
    };



    $.pincette.util.arraysEqual = function(a1, a2)
    {
      if (a1.length != a2.length)
      {
        return false;
      }

      for (var i = 0; i < a1.length; ++i)
      {
        if (!$.pincette.util.valuesEqual(a1[i], a2[i]))
        {
          return false;
        }
      }

      return true;
    };



    $.pincette.util.changed = function(currentArray, newArray)
    {
      var result = {added: [], deleted: []};

      for (var i = 0; i < currentArray.length; ++i)
      {
        var found1 = false;

        for (var j1 = 0; j1 < newArray.length && !found1; ++j1)
        {
          if ($.pincette.util.valuesEqual(currentArray[i], newArray[j1]))
          {
            found1 = true;
          }
        }

        if (!found1)
        {
          result.deleted.push(currentArray[i]);
        }
      }

      for (i = 0; i < newArray.length; ++i)
      {
        var found2 = false;

        for (var j2 = 0; j2 < currentArray.length && !found2; ++j2)
        {
          if ($.pincette.util.valuesEqual(newArray[i], currentArray[j2]))
          {
            found2 = true;
          }
        }

        if (!found2)
        {
          result.added.push(newArray[i]);
        }
      }

      return result;
    };



    $.pincette.util.clearArray = function(array)
    {
      while (array.length > 0)
      {
        array.shift();
      }

      return array;
    };



    $.pincette.util.copy = function(value, deep)
    {
      var result =
        value instanceof Date ?
          new Date(value.getTime()) :
          (
            value instanceof Array ?
              $.pincette.util.copyArray(value, deep) :
              (
                value instanceof Number || value instanceof RegExp ?
                  value :
                  (
                    value instanceof Object ?
                      $.pincette.util.copyObject(value, deep) : value
                  )
              )
          );

      return result;
    };



    $.pincette.util.copyArray = function(array, deep)
    {
      var result = new Array(array.length);

      for (var i = 0; i < array.length; ++i)
      {
        result[i] = deep ? $.pincette.util.copy(array[i]) : array[i];
      }

      return result;
    };



    $.pincette.util.copyObject = function(object, deep)
    {
      var result = {};

      for (var name in object)
      {
        if (object.hasOwnProperty(name))
        {
          result[name] =
            deep ? $.pincette.util.copy(object[name]) : object[name];
        }
      }

      return result;
    };



    $.pincette.util.correctLanguageTag = function(tag)
    {
      var index = tag.indexOf('-');
      var result =
        index == -1 ?
          tag :
          (
            tag.substring(0, index + 1) +
              tag.substring(index + 1).toUpperCase()
          );

      return result;
    };



    $.pincette.util.dateISO8601 = function(date)
    {
      var result =
        String(date.getFullYear()) + '-' +
          $.pincette.util.pad(String(date.getMonth() + 1), 2) + '-' +
          $.pincette.util.pad(String(date.getDate()), 2);

      return result;
    };



    $.pincette.util.deleteByProperty = function(array, name, value)
    {
      for (var i = 0; i < array.length; ++i)
      {
        if (array[i][name] == value)
        {
          array.splice(i, 1);

          return true;
        }
      }

      return false;
    };



    $.pincette.util.displayDate = function(date, language)
    {
      var result =
        $.pincette.util.getShortDateFormat(language).
          replace(/dd/, $.pincette.util.pad(date.getDate(), 2)).
          replace(/d/, date.getDate()).
          replace(/mm/, $.pincette.util.pad(date.getMonth() + 1, 2)).
          replace(/m/, date.getMonth() + 1).
          replace(/yy/, date.getFullYear()).
          replace(/y/, date.getYear());

      return result;
    };



    $.pincette.util.displayDateTime = function(date, language)
    {
      var result =
        $.pincette.util.displayDate(date, language) + ' ' +
        $.pincette.util.displayTime(date, language);

      return result;
    };



    $.pincette.util.displayTime = function(date, language)
    {
      var result =
        $.pincette.util.getTimeFormat(language).
          replace(/HH/, date.getHours()).
          replace
          (
            /hh/,
            $.pincette.util.pad
            (
              date.getHours() > 12 ?
                (date.getHours() - 12) :
                (date.getHours() === 0 ? 12 : date.getHours()),
              2
            )
          ).replace(/mm/, $.pincette.util.pad(date.getMinutes(), 2)).
            replace(/ss/, $.pincette.util.pad(date.getSeconds(), 2));
      var index = result.indexOf("|");

      if (index != -1)
      {
        if (date.getHours() > 11)
        {
          result =
            (
              result.substring(0, result.lastIndexOf(' ') + 1) +
                result.substring(index + 1)
            ).replace(/ /, '\u00a0');
        }
        else
        {
          result = result.substring(0, index);
        }
      }

      return result;
    };



    $.pincette.util.endsWith = function(s, suffix)
    {
      if (suffix.length > s.length)
      {
        return false;
      }

      for (var i = 0; i < suffix.length; ++i)
      {
        if (suffix.charAt(i) != s.charAt(s.length - suffix.length + i))
        {
          return false;
        }
      }

      return true;
    };



    $.pincette.util.escapeXMLText = function(text)
    {
      var result = text.replace(/&/, '&amp;').replace(/</, '&lt;');

      for (var i = 0; i < result.length; ++i)
      {
        var code = result.charCodeAt(i);

        if (code < 32 || code > 127)
        {
          result =
            result.substring(0, i) + '&#' + code + ';' +
              result.substring(i + 1);
        }
      }

      return result;
    };



    $.pincette.util.fromCamelCase = function(name, separator)
    {
      var result = '';

      for (var i = 0; i < name.length; ++i)
      {
        var c = name.charAt(i);

        result += c >= 'A' && c <= 'Z' ? (separator + c.toLowerCase()) : c;
        
      }

      return result;
    };



    $.pincette.util.getByProperty = function(array, name, value)
    {
      for (var i = 0; i < array.length; ++i)
      {
        if (array[i][name] == value)
        {
          return array[i];
        }
      }

      return null;
    };



    $.pincette.util.getClosestRow = function(element)
    {
      var result =
        element.parents().filter($.pincette.util.selectTableRows).first();

      return result;
    };



    $.pincette.util.getCountry = function(languageTag)
    {
      var index = languageTag.indexOf('-');

      return index == -1 ? null : languageTag.substring(index + 1);
    };



    $.pincette.util.getExtension = function(s)
    {
      var index = s.lastIndexOf('.');

      return index == -1 ? null : s.substring(index + 1);
    };



    $.pincette.util.getExtensionFromMimeType = function(mimeType)
    {
      return mimeTypeExtensions[mimeType];
    };



    $.pincette.util.getKeys = function(object)
    {
      var result = [];

      for (var key in object)
      {
        if (object.hasOwnProperty(key))
        {
          result.push(key);
        }
      }

      return result;
    };



    $.pincette.util.getLanguage = function(languageTag)
    {
      var result = languageTag.substring(0, 2);

      return result;
    };



    $.pincette.util.getLastPathSegment = function(path)
    {
      path = path.replace(/\\/g, '/');

      var result =
        path.substring
        (
          path.lastIndexOf('/', path.length - 2) + 1,
          path.charAt(path.length - 1) == '/' ? (path.length - 1) : path.length
        );

      return result;
    };



    $.pincette.util.getLocale = function()
    {
      var parameters = $.pincette.util.url.getParameters(location.href);
      var result =
        parameters.lang ?
          parameters.lang[0] :
          (
            parameters.language ?
              parameters.language[0] :
              (
                $.pincette.util._preferredLanguage ?
                  $.pincette.util._preferredLanguage :
                  (
                    navigator.userLanguage ? 
                      navigator.userLanguage :
                      (
                        navigator.browserLanguage ?
                          navigator.browserLanguage :
                          (navigator.language ? navigator.language : null)
                      )
                  )
              )
          );

      return result ? result.toLowerCase() : null;
    };



    $.pincette.util.getLongest = function(words)
    {
      var longest = -1;

      for (var i = 0; i < words.length; ++i)
      {
        if (longest == -1 || words[i].length > words[longest].length)
        {
          longest = i;
        }
      }

      return longest > -1 ? words[longest] : null;
    };



    $.pincette.util.getMimeTypeFromExtension = function(s)
    {
      var extension = $.pincette.util.getExtension(s);

      return extension ? extensionMimeTypes[extension] : null;
    };



    $.pincette.util.getMimeTypeLabel = function(mimeType)
    {
      var map =
        $.pincette.util.
          perLanguage(mimeTypeLabelMap, $.pincette.util.getLocale());

      return map[mimeType];
    };



    $.pincette.util.getParent = function(path)
    {
      path = path.replace(/\\/g, '/');

      var result =
        path.substring
        (
          0,
          path.lastIndexOf('/', path.length - 2) + 1
        );

      return result;
    };



    $.pincette.util.getPathSegments = function(path)
    {
      var result = [];
      var segments = path.split('/');

      for (var i = 0; i < segments.length; ++i)
      {
        if (segments[i] !== '')
        {
          result.push(segments[i]);
        }
      }

      return result;
    };



    $.pincette.util.getProperties = function(array, name)
    {
      var result = [];

      for (var i = 0; i < array.length; ++i)
      {
        result.push(array[i][name]);
      }

      return result;
    };



    $.pincette.util.getResource = function(key)
    {
      var map =
        $.pincette.util.perLanguage(resources, $.pincette.util.getLocale());

      return map[key];
    };



    $.pincette.util.getShortDateFormat = function(language)
    {
      var result =
        $.pincette.util.perLanguage
        (
          shortDateFormats,
          language ? language : $.pincette.util.getLocale()
        );

      return result;
    };



    $.pincette.util.getTimeFormat = function(language)
    {
      var result =
        $.pincette.util.perLanguage
        (
          timeFormats,
          language ? language : $.pincette.util.getLocale()
        );

      return result;
    };



    $.pincette.util.inArray = function(array, value)
    {
      return $.pincette.util.indexOf(array, value) != -1;
    };



    $.pincette.util.indexOf = function(array, value)
    {
      for (var i = 0; i < array.length; ++i)
      {
        if ($.pincette.util.valuesEqual(array[i], value))
        {
          return i;
        }
      }

      return -1;
    };



    $.pincette.util.inherit = function(from, to)
    {
      for (var prop in from)
      {
        if (!to[prop])
        {
          to[prop] = from[prop];
        }
      }

      return to;
    };



    $.pincette.util.intDiv = function(n1, n2)
    {
      return Number((n1 / n2) - 0.5).toFixed(0);
    };



    $.pincette.util.intersect = function(a1, a2)
    {
      var result = [];

      for (var i = 0; i < a1.length; ++i)
      {
        for (var j = 0; j < a2.length; ++j)
        {
          if (a1[i] == a2[j])
          {
            result.push(a1[i]);
          }
        }
      }

      return result;
    };



    $.pincette.util.isBeforeDate = function(date1, date2)
    {
      var result =
        date1.getFullYear() < date2.getFullYear() ||
          (
            date1.getFullYear() == date2.getFullYear() &&
              date1.getMonth() < date2.getMonth()
          ) ||
          (
            date1.getFullYear() == date2.getFullYear() &&
              date1.getMonth() == date2.getMonth() &&
              date1.getDate() < date2.getDate()
          );

      return result;
    };



    $.pincette.util.isDate = function(s)
    {
      var result =
        $.pincette.util.parseDate(s, $.pincette.util.getShortDateFormat()) !==
          null;

      return result;
    };



    $.pincette.util.isEmail = function(s)
    {
      return s.match(emailPattern);
    };



    $.pincette.util.isFloat = function(s)
    {
      return s.match(floatPattern);
    };



    $.pincette.util.isIE = function(lessOrEqual)
    {
      var result = navigator.userAgent.match(/MSIE (\d+)\.\d+/);

      return result != null && Number(result[1]) <= lessOrEqual;
    };



    $.pincette.util.isInteger = function(s)
    {
      return s.match(intPattern);
    };



    $.pincette.util.isLetter = function(c)
    {
      var result =
        $.pincette.util.isLowerCaseLetter(c) ||
          $.pincette.util.isUpperCaseLetter(c);

      return result;
    };



    $.pincette.util.isLowerCaseLetter = function(c)
    {
      return lowerCaseLetters[c];
    };



    $.pincette.util.isMobileLarge = function()
    {
      return window.navigator.userAgent.match(mobileLargePattern);
    };



    $.pincette.util.isMobileSmall = function()
    {
      return window.navigator.userAgent.match(mobileSmallPattern);
    };



    $.pincette.util.isNumber = function(s)
    {
      return $.pincette.util.isInteger(s) || $.pincette.util.isFloat(s);
    };



    $.pincette.util.isTime = function(s)
    {
      var result =
        $.pincette.util.parseDate
        (
          s,
          $.pincette.util.getShortDateFormat(),
          $.pincette.util.getTimeFormat()
        ) !== null;

      return result;
    };



    $.pincette.util.isTouch = function()
    {
      return $.pincette.util.isMobileSmall() || $.pincette.util.isMobileLarge();
    };



    $.pincette.util.isUpperCaseLetter = function(c)
    {
      return upperCaseLetters[c];
    };



    $.pincette.util.objectsEqual = function(o1, o2)
    {
      if (o1.equals && o1.equals(o2))
      {
        return true;
      }

      for (var name in o1)
      {
        if (!$.pincette.util.valuesEqual(o1[name], o2[name]))
        {
          return false;
        }
      }

      for (name in o2)
      {
        if (!$.pincette.util.valuesEqual(o1[name], o2[name]))
        {
          return false;
        }
      }

      return true;
    };



    $.pincette.util.objectsPerField = function(objects, field)
    {
      var result = {};

      for (var i = 0; i < objects.length; ++i)
      {
        result[objects[i][field]] = objects[i];
      }

      return result;
    };



    $.pincette.util.openLocally = function(url)
    {
      var iframe = $('body > #openlocallyiframe');

      if (iframe.length === 0)
      {
        iframe =
          $('<iframe id="openlocallyiframe" style="display: none"></iframe>').
            appendTo($('body'));
      }

      if
      (
        $.pincette.util.startsWith(url, 'mailto:')	&&
        (
          navigator.userAgent.indexOf('Chrome') != -1	||
          $.pincette.util.isIE(10)
        )
      )
      {
        var a = $('<a href="' + url + '" target="_top"></a>').appendTo(iframe);

        a[0].click();
        a.remove();
      }
      else
      {
        iframe.attr('src', url);
      }
    };



    $.pincette.util.pad = function(value, padding)
    {
      var result = String(value);

      while (result.length < padding)
      {
        result = '0' + result;
      }

      return result;
    };



    $.pincette.util.parseDate = function(s, dateFormat, timeFormat)
    {
      if (!dateFormat)
      {
        dateFormat = $.pincette.util.getShortDateFormat();
      }

      var matches =
        s.match
        (
          new RegExp
          (
            dateFormatToPattern(dateFormat) +
              (timeFormat ? (' +' + timeFormatToPattern(timeFormat)) : ''),
            'i'
          )
        );

      if (matches === null)
      {
        return null;
      }

      var day = dateFormat.indexOf('d');
      var month = dateFormat.indexOf('m');
      var year = dateFormat.indexOf('y');
      var date =
        new Date
        (
          Number
          (
            matches
            [
              year < month && year < day ?
                1 : (year < day || year < month ? 2 : 3)
            ]
          ),
          Number
          (
            matches
            [
              month < year && month < day ?
                1 : (month < day || month < year ? 2 : 3)
            ]
          ) - 1,
          Number
          (
            matches
            [
              day < year && day < month ?
                1 : (day < month || day < year ? 2 : 3)
            ]
          ),
          timeFormat ?
            (
              Number(matches[4]) === 0 || Number(matches[4]) > 12 ||
                (!matches[7] && !matches[8]) ?
                // a.m.          p.m.
                Number(matches[4]) :
                (
                  matches[7] ?
                    (Number(matches[4]) == 12 ? 0 : Number(matches[4])) :
                    (Number(matches[4]) == 12 ? 12 : Number(matches[4]) + 12)
                )
            ) : 0,
          timeFormat ? Number(matches[5]) : 0,
          timeFormat ? Number(matches[6]) : 0,
          0
        );

      return date;
    };



    $.pincette.util.parseHttpDate = function(s)
    {
      var matches;
      var result =
        (matches = s.match(rfc1123DatePattern)) !== null ?
          parseRfc1123Date(matches) :
          (
            (matches = s.match(rfc850DatePattern)) !== null ?
              parseRfc850Date(matches) :
              (
                (matches = s.match(asctimeDatePattern)) !== null ?
                  parseAsctimeDate(matches) : null
              )
          );

      return result;
    };



    $.pincette.util.parseISO8601 = function(s)
    {
      var matches = s.match(timestampPattern);

      if (matches === null)
      {
        return null;
      }

      var millis =
        Date.UTC
        (
          Number(matches[1]),
          matches[3] ? (Number(matches[3]) - 1) : 0,
          matches[5] ? Number(matches[5]) : 1,
          matches[7] ? Number(matches[7]) : 0,
          matches[8] ? Number(matches[8]) : 0,
          matches[10] ? Number(matches[10]) : 0,
          matches[12] ? (Number("0." + matches[12]) * 1000) : 0
        );

      if (matches[14] && matches[14] != 'Z')
      {
        millis +=
          getTimeZoneOffset
          (
            Number(matches[15]),
            Number(matches[16]),
            Number(matches[17])
          );
      }

      return new Date(millis);
    };



    $.pincette.util.parseTime = function(s, format)
    {
      var matches = s.match(new RegExp(timeFormatToPattern(format)));

      if (matches === null)
      {
        return null;
      }

      var day = format.indexOf('d');
      var month = format.indexOf('m');
      var year = format.indexOf('y');
      var date =
        new Date
        (
          Number
          (
            matches
            [
              year < month && year < day ?
                1 : (year < day || year < month ? 2 : 3)
            ]
          ),
          Number
          (
            matches
            [
              month < year && month < day ?
                1 : (month < day || month < year ? 2 : 3)
            ]
          ) - 1,
          Number
          (
            matches
            [
              day < year && day < month ?
                1 : (day < month || day < year ? 2 : 3)
            ]
          ),
          0,
          0,
          0,
          0
        );

      return date;
    };



    $.pincette.util.perLanguage = function(map, language)
    {
      if (!language)
      {
        language = $.pincette.util.getLocale();
      }

      language = language.toLowerCase();

      var result = map[language];

      if (!result && language.indexOf('-') != -1)
      {
        result = map[language.substring(0, language.indexOf('-'))];
      }

      return result ? result : map.en;
    };



    $.pincette.util.removeAll = function(array1, array2)
    {
      var result = [];

      for (var i = 0; i < array1.length; ++i)
      {
        if (!$.pincette.util.inArray(array2, array1[i]))
        {
          result.push(array1[i]);
        }
      }

      return result;
    };



    $.pincette.util.removeExtension = function(s)
    {
      var index = s.lastIndexOf('.');

      return index == -1 ? s : s.substring(0, index);
    };



    $.pincette.util.replaceParameters = function(s, data)
    {
      var result = replaceParameters(s, data, '{', '}');

      result = replaceParameters(result, data, '[', ']');

      return result;
    };



    $.pincette.util.removeEmpty = function(array)
    {
      var result = [];

      for (var i = 0; i < array.length; ++i)
      {
        if (array[i] !== '')
        {
          result.push(array[i]);
        }
      }

      return result;
    };



    $.pincette.util.selectTableRows = function()
    {
      return $(this).css('display') == 'table-row';
    };



    $.pincette.util.setPreferredLanguage = function(language)
    {
      $.pincette.util._preferredLanguage = language;
    };



    $.pincette.util.sortCaseInsensitive = function(array)
    {
      array.sort
      (
        function(o1, o2)
        {
          var result =
            o1.toLocaleString($.pincette.util.getLocale()).toLocaleLowerCase().
              localeCompare
              (
                o2.toLocaleString($.pincette.util.getLocale()).
                  toLocaleLowerCase()
              );

          return result;
        }
      );

      return array;
    };



    $.pincette.util.startsWith = function(s, prefix)
    {
      if (prefix.length > s.length)
      {
        return false;
      }

      for (var i = 0; i < prefix.length; ++i)
      {
        if (prefix.charAt(i) != s.charAt(i))
        {
          return false;
        }
      }

      return true;
    };



    $.pincette.util.stripTrailingSlash = function(s)
    {
      return s.charAt(s.length - 1) == '/' ? s.substring(0, s.length - 1) : s;
    };



    $.pincette.util.timestampISO8601 = function(date)
    {
      var result =
        $.pincette.util.dateISO8601(date) + 'T' +
          $.pincette.util.pad(String(date.getHours()), 2) + ':' +
          $.pincette.util.pad(String(date.getMinutes()), 2) + ':' +
          $.pincette.util.pad(String(date.getSeconds()), 2) +
          (
            date.getMilliseconds() > 0 ?
              ('.' + String(date.getMilliseconds())) : ''
          ) +
          (date.getTimezoneOffset() < 0 ? '+' : '-') +
          $.pincette.util.pad
          (
            String
            (
              $.pincette.util.intDiv(Math.abs(date.getTimezoneOffset()), 60)
            ),
            2
          ) + ':' +
          $.pincette.util.
            pad(String(Math.abs(date.getTimezoneOffset()) % 60), 2);

      return result;
    };



    $.pincette.util.toCamelCase = function(name, separator, firstUpper)
    {
      var result = '';
      var segments = name.split(separator);

      for (var i = 0; i < segments.length; ++i)
      {
        result +=
          (
            i > 0 || firstUpper ?
              segments[i].charAt(0).toUpperCase() :
              segments[i].charAt(0).toLowerCase()
          ) + segments[i].substring(1);
      }

      return result;
    };



    $.pincette.util.valuesEqual = function(v1, v2)
    {
      var result =
        typeof(v1) == 'function' || typeof(v2) == 'function' ?
          v1 === v2 :
          (
            (typeof(v1) == 'object' && typeof(v2) != 'object') ||
              (typeof(v1) != 'object' && typeof(v2) == 'object') ||
              ($.isArray(v1) && !$.isArray(v2)) ||
              (!$.isArray(v1) && $.isArray(v2)) ?
              false :
              (
                $.isArray(v1) ?
                  $.pincette.util.arraysEqual(v1, v2) :
                  (
                    v1 instanceof Date && v2 instanceof Date ?
                      v1.getTime() == v2.getTime() :
                      (
                        typeof(v1) == 'object' ?
                          $.pincette.util.objectsEqual(v1, v2) : v1 == v2
                      )
                  )
              )
          );

      return result;
    };



    $.pincette.util.dc.getElementOrTerm = function(label)
    {
      for (var language in labelToElementMap)
      {
        if (labelToElementMap.hasOwnProperty(language))
        {
          var map1 = labelToElementMap[language];

          if (map1[label])
          {
            return map1[label];
          }
        }
      }

      for (language in labelToTermMap)
      {
        if (labelToTermMap.hasOwnProperty(language))
        {
          var map2 = labelToTermMap[language];

          if (map2[label])
          {
            return map2[label];
          }
        }
      }

      return null;
    };



    $.pincette.util.dc.getLabel = function(elementOrTerm, language)
    {
      if (!language)
      {
        language = $.pincette.util.getLocale();
      }

      var map =
        $.pincette.util.perLanguage
        (
          elementOrTerm.indexOf('dc_') === 0 ?
            elementToLabelMap : termToLabelMap,
          language
        );

      return map[elementOrTerm];
    };



    $.pincette.util.dom.clearNode = function(node)
    {
      if (node)
      {
        while (node.hasChildNodes())
        {
          node.removeChild(node.firstChild);
        }
      }
    };



    $.pincette.util.dom.getLocalName = function(node)
    {
      if (node.localName)
      {
        return node.localName;
      }

      var i = node.nodeName.indexOf(':');
      var result = i != -1 ? node.nodeName.substring(i + 1) : node.nodeName;

      return result;
    };



    $.pincette.util.dom.getQName = function(node)
    {
      var result =
        {
          localName: $.pincette.util.dom.getLocalName(node),
          namespaceURI: node.namespaceURI
        };

      return result;
    };



    $.pincette.util.dom.getText = function(node)
    {
      if (!node)
      {
        return null;
      }

      var result = '';

      for (var n = node.firstChild; n; n = n.nextSibling)
      {
        if (n.nodeType == 3)
        {
          result += n.nodeValue;
        }
        else
        {
          if (n.nodeType == 1)
          {
            result += $.pincette.util.dom.getText(n);
          }
        }
      }

      return result;
    };



    $.pincette.util.dom.hasName = function(node, namespaceURI, localName)
    {
      // This takes into account that namespaces are not supported in IE < 9.

      var result =
        (
          !namespaceURI || !node.namespaceURI ||
            node.namespaceURI == namespaceURI
        ) && $.pincette.util.dom.getLocalName(node) == localName;

      return result;
    };



    $.pincette.util.dom.selectChildren = function(node, equal, refData)
    {
      var children = [];
      var i = 0;

      for (var n = node.firstChild; n; n = n.nextSibling)
      {
        if (!equal || equal(n, refData))
        {
          children[i++] = n;
        }
      }

      return children;
    };



    $.pincette.util.dom.selectElements = function(node, localName, namespaceURI)
    {
      var children =
        localName ?
          $.pincette.util.dom.selectChildren
          (
            node,
            nameSelector,
            {localName : localName, namespaceURI: namespaceURI}
          ) : $.pincette.util.dom.selectChildren(node, elementSelector);

      return children;
    };



    $.pincette.util.dom.selectFirstChild = function(node, equal, refData)
    {
      for (var n = node.firstChild; n; n = n.nextSibling)
      {
        if (!equal || equal(n, refData))
        {
          return n;
        }
      }

      return null;
    };



    $.pincette.util.dom.selectFirstElement =
      function(node, localName, namespaceURI)
    {
      var child =
        localName ?
          $.pincette.util.dom.selectFirstChild
          (
            node,
            nameSelector,
            {localName : localName, namespaceURI: namespaceURI}
          ) : $.pincette.util.dom.selectFirstChild(node, elementSelector);

      return child;
    };



    $.pincette.util.dom.selectPath = function(node, path)
    {
      var children = [];

      selectPath(node, path, 0, children);

      return children;
    };



    $.pincette.util.dom.toJson = function(node)
    {
      var elements = $.pincette.util.dom.selectElements(node);
      var result = {};

      for (var i = 0; i < elements.length; ++i)
      {
        var name =
          $.pincette.util.toCamelCase
          (
            $.pincette.util.dom.getLocalName(elements[i]),
            '-',
            false
          );

        if (result[name])
        {
          if (!$.isArray(result[name]))
          {
            var first = result[name];

            result[name] = [];
            result[name][0] = first;
          }

          result[name].push(elementToValue(elements[i]));
        }
        else
        {
          result[name] = elementToValue(elements[i]);
        }
      }

      return result;
    };



    $.pincette.util.jq.sort = function(elements, criterion)
    {
      var array = elements.toArray();

      array.sort(criterion);

      for (var i = 0; i < array.length; ++i)
      {
        var parent = $(array[i]).parent();

        $(array[i]).detach();
        parent.append(array[i]);
      }

      return $(array);
    };



    $.pincette.util.jq.sortContents = function(elements, criterion)
    {
      $(elements).each
      (
        function()
        {
          $.pincette.util.jq.sort($(this).children(), criterion);
        }
      );

      return $(elements);
    };



    $.pincette.util.ui.addClose = function(element, onClose)
    {
      var close = $('<div class="pincette-close"/>').appendTo(element);

      close.css('position', 'absolute');

      if (onClose)
      {
        close.click(onClose);
      }

      close.offset
      (
        {
          top: element.offset().top,
          left:
            element.offset().left + element.outerWidth() - close.outerWidth()
        }
      );
    };



    $.pincette.util.ui.addMessage = function(reporter, message, error)
    {
      var body = $('.body', reporter);
      var messages = $('.messages', reporter);

      messages.
        append('<div' + (error ? ' class="error">' : '>') + message + '</div>');
      body.scrollTop(messages.height() - body.offset().top);
    };



    $.pincette.util.ui.boxMenu =
      function(element, createBox, createItems, isSubmenu)
    {
      function handler(e)
      {
        e.stopPropagation();

        var box = element.data('pincette-boxmenu-create-box')();
        var close = function(){};
        var items = element.data('pincette-boxmenu-items')();
        var template = $('.template', box);

        if (template)
        {
          for (var i = 0; i < items.length; ++i)
          {
            var copy = template.clone();
            var item = $('.item', copy);

            copy.removeClass('template');
            template.parent().append(copy);
            item.append(items[i].label);

            if (items[i].action)
            {
              addBoxMenuItemEvent(item, items[i]);
            }

            if (items[i].createItems)
            {
              $.pincette.util.ui.
                boxMenu(item, createBox, items[i].createItems, true);
            }
          }

          template.remove();

          // Comes at the end in order to have the natural size of the box.
          $('.item', box).data
          (
            'pincette-box-menu-close',
            $.pincette.util.ui.modal(box, {stack: !isSubmenu})
          );
        }
      }

      element.data('pincette-boxmenu-create-box', createBox);
      element.data('pincette-boxmenu-items', createItems);

      if (!element.data('pincette-boxmenu-handler'))
      {
        element.click(handler);
        element.data('pincette-boxmenu-handler', handler);
      }
    };



    $.pincette.util.ui.button = function(element)
    {
      function clickHandler()
      {
        element.addClass('clicked');
        window.setInterval(function(){element.removeClass('clicked');}, 500);
      }

      if (!element.data('pincette-button-clicked'))
      {
        element.data('pincette-button-clicked', clickHandler);
        element.click(clickHandler);
      }
    };



    $.pincette.util.ui.confirm = function(onYes, onNo, template)
    {
      $.pincette.util.ui.yesOrNo
      (
        $.pincette.util.getResource('msg-confirm'),
        onYes,
        onNo,
        template
      );
    };



    $.pincette.util.ui.dialogBox =
      function(element, options, template, modalOptions)
    {
      function enter(e)
      {
        if (e.which == '13')
        {
          $('.ok', box).click();
        }
      }

      function closeDialog(action)
      {
        ok = action;
        close();
      }

      function disableButtons(box)
      {
        okEnabled = false;
        cancelEnabled = false;
        $('.ok', box).addClass('disabled');
        $('.cancel', box).addClass('disabled');
      }

      function enableButtons(box)
      {
        okEnabled = true;
        cancelEnabled = true;
        $('.ok', box).removeClass('disabled');
        $('.cancel', box).removeClass('disabled');
      }

      function handleCancel()
      {
        if (cancelEnabled)
        {
          ok = false;
          close();
        }
      }

      function handleOK()
      {
        if (okEnabled)
        {
          ok = true;
          close();
        }
      }

      function userClose(close)
      {
        $('input:enabled', box).unbind('keypress', enter);
        $('.ok', box).unbind('click', handleOK);
        $('.cancel', box).unbind('click', handleCancel);

        close();

        if (options.afterClose)
        {
          options.afterClose(element);
        }
      }

      var box;
      var cancelEnabled = true;
      var ok = false;
      var okEnabled = true;

      if (template && template.length > 0)
      {
        box = template;

        if (element)
        {
          box.append(element);
        }

        $('.pincette-button', box).
          each(function(){$.pincette.util.ui.button($(this));});
        $('.pincette-field', box).
          each(function(){$.pincette.util.ui.field($(this));});
      }
      else
      {
        box = $('<div class="pincette-dialog-box"></div>').append(element);
      }

      if ($('.ok', box).length === 0 && $('.cancel', box).length === 0)
      {
        box.append
        (
          '<div class="pincette-dialog-box-buttons">' +
            '<button class="ok" type="submit">' +
            (
              options.okButtonText ?
                options.okButtonText : $.pincette.util.getResource('label-ok')
            ) +
            '</button><button class="cancel" type="button">' +
            (
              options.cancelButtonText ?
                options.cancelButtonText :
                $.pincette.util.getResource('label-cancel')
            ) + '</button></div>'
        );
      }
      else
      {
        // The "close" class shouldn't be there. We remove it in order not to
        // break anything.
        $('.ok.close,.cancel.close', box).removeClass('close');
      }

      if (!element)
      {
        element = template;
      }

      $('input:enabled', box).bind('keypress', enter);

      var close =
        $.pincette.util.ui.modal
        (
          box,
          $.extend
          (
            modalOptions ? modalOptions : {},
            {
              close: handleCancel,
              onClose:
                function(container, overlay, box, close)
                {
                  if (!ok || !options.validate || options.validate(element))
                  {
                    if (ok)
                    {
                      if (options.onOK)
                      {
                        disableButtons(box);

                        if
                        (
                          options.onOK
                          (
                            element,
                            function(){userClose(close);},
                            function(){enableButtons(box);}
                          )
                        )
                        {
                          userClose(close);
                        }
                      }
                      else
                      {
                        userClose(close);
                      }
                    }
                    else
                    {
                      if (options.onCancel)
                      {
                        options.onCancel(element);
                      }

                      userClose(close);
                    }
                  }
                },
              onShow:
                function(container, overlay, box)
                {
                  function showBox()
                  {
                    if (options.onShow)
                    {
                      options.onShow(element);
                    }

                    box.width(element.outerWidth());
                  }

                  overlay.show();
                  container.show();
                  element.show(0, showBox);
                },
              afterShow: options.afterShow
            }
          )
        );

      $('.ok', box).bind('click', handleOK);
      $('.cancel', box).bind('click', handleCancel);

      return closeDialog;
    };



    $.pincette.util.ui.displaySize = function(size)
    {
      var result =
        size < 10000 ?
          Number(size).toLocaleString($.pincette.util.getLocale()) :
          (
            size < 1024 * 1024 ?
              (
                Number(Math.round(100 * (size / 1024)) / 100).
                  toLocaleString($.pincette.util.getLocale()) +
                  '\u00a0KB'
              ) :
              (
                size < 1024 * 1024 * 1024 ?
                  (
                    Number(Math.round(100 * (size / (1024 * 1024))) / 100).
                      toLocaleString($.pincette.util.getLocale()) +
                      '\u00a0MB'
                  ) :
                  (
                    Number
                    (
                      Math.round(100 * (size / (1024 * 1024 * 1024))) / 100
                    ).toLocaleString($.pincette.util.getLocale()) + '\u00a0GB'
                  )
              )
          );

      return result;
    };



    $.pincette.util.ui.editTableRows =
      function(element, initializeRow, canDeleteRow, clearRow, maxRows)
    {
      element.delegate
      (
        '.add',
        'click',
        function()
        {
          var row = $.pincette.util.getClosestRow($(this));

          if (!maxRows || row.siblings(row[0].tagName).length + 1 < maxRows)
          {
            var newRow = row.clone();

            row.after(newRow);

            if (initializeRow)
            {
              initializeRow(newRow);
            }
          }
        }
      );

      element.delegate
      (
        '.delete',
        'click',
        function()
        {
          var row = $.pincette.util.getClosestRow($(this));

          if (row.siblings().length > 0 && (!canDeleteRow || canDeleteRow(row)))
          {
            row.remove();
          }
          else
          {
            if (clearRow)
            {
              clearRow(row);
            }
          }
        }
      );

      element.delegate
      (
        '.up',
        'click',
        function()
        {
          var row = $.pincette.util.getClosestRow($(this));

          row.prev().before(row);
        }
      );

      element.delegate
      (
        '.down',
        'click',
        function()
        {
          var row = $.pincette.util.getClosestRow($(this));

          row.next().after(row);
        }
      );
    };



    $.pincette.util.ui.field = function(element)
    {
      var clear =
        element.parents('.pincette-field-wrapper').length === 0 ?
          $('<span class="clear"></span>').appendTo
          (
            element.wrap('<span class="pincette-field-wrapper"></span>').
              parent()
          ) : $('span.clear', element.parents('.pincette-field-wrapper'));

      function clearField()
      {
        element.val(element.attr('alt'));
        element.addClass('cleared');
        clear.addClass('disabled');
      }

      if (!element.data('pincette-field-events'))
      {
        element.data('pincette-field-events', true);

        clear.click
        (
          function()
          {
            clearField();
            element.focus();
          }
        );

        element.focus
        (
          function()
          {
            if (element.hasClass('cleared'))
            {
              element.val('');
              element.removeClass('cleared');
            }
          }
        );

        element.keydown
        (
          function()
          {
            if (element.val().length === 0)
            {
              clear.removeClass('disabled');
            }
          }
        );

        element.blur
        (
          function()
          {
            if (element.val().trim().length === 0)
            {
              clearField();
            }
          }
        );
      }

      if (element.val().length === 0 || element.val() == element.attr('alt'))
      {
        clearField();
      }
      else
      {
        element.removeClass('cleared');
        clear.removeClass('disabled');
      }
    };



    $.pincette.util.ui.getDate =
      function(initialValue, onChoose, template, yearFrom, yearTo, options)
    {
      var result = {};

      getDate(initialValue, template, yearFrom, yearTo, result);

      $.pincette.util.ui.dialogBox
      (
        null,
        $.extend
        (
          {
            onOK:
              function()
              {
                if (onChoose)
                {
                  var date = new Date();

                  date.setFullYear
                  (
                    Number(result.year.val()),
                    Number(result.month.val()) - 1,
                    Number(result.day.val())
                  );

                  date.setHours(0, 0, 0, 0);
                  onChoose(date);
                }

                return true;
              }
          },
          options
        ),
        template
      );
    };



    $.pincette.util.ui.getFieldValue = function(element)
    {
      var parents = element.parents('.pincette-field-wrapper');
      var result =
        parents.length > 0 && element.val() == element.attr('alt') ?
          null : element.val();

      return result;
    };



    $.pincette.util.ui.getName =
      function(initialValue, onChoose, template, options)
    {
      var input = $('input', template);

      if (initialValue)
      {
        input.val(initialValue);
      }

      input.select();

      $.pincette.util.ui.dialogBox
      (
        null,
        $.extend
        (
          {
            onOK:
              function(element, userClose, reEnableDialogBox)
              {
                if (onChoose && input.val() && input.val().trim().length > 0)
                {
                  onChoose(input.val().trim(), userClose, reEnableDialogBox);
                }
                else
                {
                  userClose();
                }
              }
          },
          options
        ),
        template
      );
    };



    $.pincette.util.ui.getPeriod =
      function
      (
        initialValueFrom,
        initialValueTo,
        onChoose,
        template,
        yearFrom,
        yearTo,
        options
      )
    {
      var from = {};
      var to = {};

      getDate(initialValueFrom, $('.from', template), yearFrom, yearTo, from);
      getDate(initialValueTo, $('.to', template), yearFrom, yearTo, to);

      $.pincette.util.ui.dialogBox
      (
        null,
        $.extend
        (
          {
            onOK:
              function()
              {
                if (onChoose)
                {
                  var dateFrom = new Date();
                  var dateTo = new Date();

                  dateFrom.setFullYear
                  (
                    Number(from.year.val()),
                    Number(from.month.val()) - 1,
                    Number(from.day.val())
                  );

                  dateFrom.setHours(0, 0, 0, 0);

                  dateTo.setFullYear
                  (
                    Number(to.year.val()),
                    Number(to.month.val()) - 1,
                    Number(to.day.val())
                  );

                  dateTo.setHours(23, 59, 59, 0);
                  onChoose(dateFrom, dateTo);
                }

                return true;
              }
          },
          options
        ),
        template
      );
    };



    $.pincette.util.ui.menu = function(element, createItems)
    {
      $.pincette.util.ui.popup
      (
        element,
        function()
        {
          var items = createItems();
          var ul = $('<ul class="pincette-menu"></ul>');

          for (var i = 0; i < items.length; ++i)
          {
            addMenuItemEvent
            (
              $('<li>' + items[i].label + '</li>').appendTo(ul),
              items[i]
            );
          }

          return ul;
        },
        true
      );
    };



    $.pincette.util.ui.messageBox =
      function(message, buttonText, whenClosed, template)
    {
      var box;

      if (template && template.length > 0)
      {
        box = template;
        $('.text', box).append(message);
      }
      else
      {
        box =
          $(
            '<div class="pincette-message-box"><div class="text">' + message +
              '</div></div>'
          );
      }

      if ($('button', box).add('.ok', box).length === 0)
      {
        box.append
        (
          '<div class="button"><button type="button">' +
            (
              buttonText ?
                buttonText : $.pincette.util.getResource('label-ok')
            ) + '</button></div>'
        );
      }

      var close =
        $.pincette.util.ui.modal
        (
          box,
          {
            onClose:
              function(container, overlay, box, close)
              {
                close();

                if (whenClosed)
                {
                  whenClosed();
                }
              },
            onShow:
              function(container, overlay, box)
              {
                $('button', box).add('.ok', box).click(function(){close();});
                overlay.show();
                container.show();
              }
          }
        );
    };



    $.pincette.util.ui.modal = function(element, options)
    {
      options =
        $.extend
        (
          {
            close: returnedClose,
            centerHorizontally: true,
            centerVertically: true,
            containerClass: 'pincette-modal-container',
            overlayClass: 'pincette-modal-overlay',
            stack: true
          },
          options
        );

      function close()
      {
        if (nextSibling.length > 0)
        {
          element.insertBefore(nextSibling);
        }
        else
        {
          parent.append(element);
        }

        overlay.remove();
        $(document).unbind('keydown', handleKeys);
        $(window).unbind('resize', setOverlaySize);
      }

      function handleKeys(e)
      {
        if (e.keyCode == 9)
        {
          e.preventDefault();

          var controls = $(':input:enabled:visible', element);
          var position = -1;

          for (var i = 0; i < controls.length && position == -1; ++i)
          {
            if (controls[i] == e.target)
            {
              position = i;
            }
          }

          if (controls.length > 0)
          {
            controls
            [
              position != -1 ?
                (
                  !e.shiftKey ?
                    (position < controls.length - 1 ? (position + 1) : 0) :
                    (position > 0 ? (position - 1) : (controls.length - 1))
                ) : 0
            ].focus();
          }
        }
        else
        {
          if
          (
            e.keyCode == 27						&&
            overlay.next('.' + options.overlayClass).length === 0
              // Last stacked.
          )
          {
            e.preventDefault();
            options.close();
          }
        }
      }

      function returnedClose()
      {
        if (options && options.onClose)
        {
          options.onClose(container, overlay, element, close);
        }
        else
        {
          close();
        }

        if (options.stack)
        {
          previousOverlay.show();
        }
      }

      function setOverlaySize()
      {
        overlay.height($(document).height());
        overlay.width($(document).width());
      }

      var previousOverlay = $('div.' + options.overlayClass);
      var overlay =
        $(
          '<div class="' + options.overlayClass +
            '" style="position: absolute; top: 0; left: 0; display: none;' +
            ' z-index: 100000"/>'
        ).appendTo($('body'));
      var container =
        $(
          '<div class="' + options.containerClass + '" style="display: none; ' +
            (
              options.centerHorizontally ?
                'margin-left: auto; margin-right: auto;' : ''
            ) + '"/>'
        ).appendTo(overlay);
      var nextSibling = element.next();
      var parent = element.parent();

      container.append(element);
      element.css('display', 'inline-block');

      overlay.queue
      (
        function()
        {
          setOverlaySize();
          $(this).dequeue();
        }
      );

      if (options.stack)
      {
        previousOverlay.hide();
      }
      else
      {
        previousOverlay.remove();
      }

      if (options && options.onShow)
      {
        options.onShow(container, overlay, element);
      }
      else
      {
        overlay.show();
        container.show();
      }

      if (options.centerVertically)
      {
        container.offset
        (
          {
            top:
              $(document).scrollTop() +
                Math.max(0, ($(window).height() - container.height()) / 2)
          }
        );
      }

      $(':input:enabled:visible:first', element).focus();
      $(document).bind('keydown', handleKeys);
      $(window).bind('resize', setOverlaySize);
      container.width(element.outerWidth());
      $('.pincette-title-bar .close', element).click(options.close);
      $('.pincette-button', element).
        each(function(){$.pincette.util.ui.button($(this));});

      if (options.afterShow)
      {
        options.afterShow(container, overlay, element);
      }

      return returnedClose;
    };



    $.pincette.util.ui.modalWithClose = function(element)
    {
      var close =
        $.pincette.util.ui.modal
        (
          element,
          {
            onShow:
              function(container, overlay, box)
              {
                overlay.show();
                container.show();

                if ($('.pincette-title-bar', element).length === 0)
                {
                  $.pincette.util.ui.addClose(element, close);
                }
              }
          }
        );

      return close;
    };



    $.pincette.util.ui.popup =
      function(element, createBox, useClick, clickToDismiss)
    {
      var parent = element.offsetParent();

      element.data('pincette-popup-create-box', createBox);

      function blur(element)
      {
        if (element.data('shown'))
        {
          element.data('shown').remove();
          element.data('shown', null);
        }
      }

      function blurPoppedUp()
      {
        if (poppedUp)
        {
          blur(poppedUpTrigger);
          poppedUp.remove();
          poppedUpTrigger = null;
          poppedUp = null;
        }
      }

      function clickHandler(e)
      {
        e.stopPropagation();

        if ($(this).data('shown'))
        {
          blur($(this));
          blurPoppedUp();
        }
        else
        {
          showBox($(this));
        }
      }

      function mouseenterHandler()
      {
        showBox($(this));
      }

      function showBox(element)
      {
        blurPoppedUp();

        var shown = element.data('pincette-popup-create-box')();

        poppedUpTrigger = element;
        poppedUp = shown;
        shown.blur(function(){blur(element);});
        element.data('shown', shown);

        if (!useClick)
        {
          shown.mouseleave(function(){blur(element);});
        }

        if (clickToDismiss)
        {
          shown.click(function(){blur(element);});
        }

        shown.css('margin', '0');
        shown.css('position', 'absolute');
        $('body').append(shown);

        shown.offset
        (
          {
            top:
              element.offset().top + element.outerHeight() +
                shown.outerHeight() > $(window).height() - 30 ?
                  // A margin for scrollbars.
                (element.offset().top - shown.outerHeight()) :
                (element.offset().top + element.outerHeight()),
            left:
              element.offset().left + shown.outerWidth() >
                $(window).width() - 30 ? // A margin for scrollbars.
                (
                  element.offset().left + element.outerWidth() -
                    shown.outerWidth() +
                    (
                      $.browser.msie &&
                        (
                          $.browser.version == '7.0' ||
                            $.browser.version == '8.0'
                        ) ? 30 : 0
                    )
                ) : element.offset().left
          }
        );
      }

      if (!element.data('pincette-popup-handler'))
      {
        if (!useClick)
        {
          element.data('pincette-popup-handler', mouseenterHandler);
          element.mouseenter(mouseenterHandler);
        }
        else
        {
          element.click(clickHandler);
          element.data('pincette-popup-handler', clickHandler);
        }
      }
    };



    $.pincette.util.ui.replaceData = function(element, data)
    {
      $('*', element).contents().
        filter(function(){return this.nodeType == 3;}).each
        (
          function()
          {
            $(this).replaceWith
            (
              $.pincette.util.replaceParameters(this.data, data)
            );
          }
        );

      $('*', element).each
      (
        function()
        {
          $($(this)[0].attributes).each
          (
            function()
            {
              this.nodeValue =
                $.pincette.util.replaceParameters(this.nodeValue, data);
            }
          );
        }
      );
    };



    $.pincette.util.ui.setLanguageSelection = function(select)
    {
      select.empty();
      select.append('<option value=""/>');

      for (var i = 0; i < languages.length; ++i)
      {
        var option = $('<option></option>');

        option.attr('label', $.pincette.util.getResource(languages[i]));
        option.attr('value', languages[i]);
        option.text($.pincette.util.getResource(languages[i]));
        select.append(option);
      }

      $.pincette.util.jq.sort
      (
        $('option', select),
        function(o1, o2)
        {
          return $(o1).text().localeCompare($(o2).text());
        }
      );
    };



    $.pincette.util.ui.setFieldValue = function(element, value)
    {
      element.val(value);
      $('.cleared', element.parents('.pincette-field-wrapper')).
        removeClass('cleared');
      $('.clear', element.parents('.pincette-field-wrapper')).
        removeClass('disabled');
    };



    $.pincette.util.ui.setListIndex = function(elements)
    {
      function getFirst(element)
      {
        var text = element.text();

        if (text.length === 0)
        {
          return null;
        }

        var first = text.charAt(0).toUpperCase();

        return $.pincette.util.isLetter(first) ? first : '#';
      }

      function handleClick(element, div, symbol)
      {
        div.click(function(){element.scrollTop(symbol);});
      }

      function sortLetters(o1, o2)
      {
        return o1 == '#' ? -1 : (o2 == '#' ? 1 : o1.localeCompare(o2));
      }

      $(elements).filter('.pincette-add-list-index').each
      (
        function()
        {
          var element = $(this);

          $('.pincette-list-index', element).remove();

          if (totalContentsHeight(element) > 4 * element.innerHeight())
          {
            var index =
              $('<div class="pincette-list-index"></div>').appendTo(element);

            index.height(element.innerHeight());

            index.offset
            (
              {
                top: element.offset().top,
                left:
                  element.offset().left + element.innerWidth() -
                    index.outerWidth()
              }
            );

            var items = $('.pincette-list-index-item', element);
            var letters = [];
            var notSorted = false;
            var previous;
            var size = 0;
            var symbols = {};

            items.each
            (
              function(index)
              {
                if (!notSorted)
                {
                  var first = getFirst($(this));

                  if (letters.length > 0 && first < letters[letters.length - 1])
                  {
                    notSorted = true;
                  }
                  else
                  {
                    if (first && (!previous || previous != first))
                    {
                      letters.push(first);
                      symbols[first] = $(this).position().top;
                      size++;
                      previous = first;
                    }
                  }
                }
              }
            );

            if (notSorted)
            {
              index.remove();
            }
            else
            {
              letters.sort(sortLetters);

              for (var i = 0; i < letters.length; ++i)
              {
                var div = $('<div>' + letters[i] + '</div>').appendTo(index);

                div.css('line-height', index.innerHeight() / size + 'px');
                handleClick(element, div, symbols[$(this).text()]);
              }
            }
          }
        }
      );

      return elements;
    };



    $.pincette.util.ui.yesOrNo =
      function(message, onYes, onNo, template, options)
    {
      var box;

      if (template && template.length > 0)
      {
        box = template;
        $('.text', box).append(message);
      }
      else
      {
        box = $('<div class="text">' + message + '</div>');
      }

      $.pincette.util.ui.dialogBox
      (
        null,
        $.extend
        (
          {
            onOK:
              function()
              {
                onYes();

                return true;
              },
            onCancel: onNo,
            okButtonText: $.pincette.util.getResource('label-yes'),
            cancelButtonText: $.pincette.util.getResource('label-no')
          },
          options
        ),
        box
      );
    };



    $.pincette.util.url.displayUrl = function(url)
    {
      var result = $.pincette.util.addWrapPoints(decodeURI(url));

      return result;
    };



    $.pincette.util.url.encodeUriPath = function(path)
    {
      var result = '';
      var segments = $.pincette.util.getPathSegments(path);

      for (var i = 0; i < segments.length; ++i)
      {
        result += '/' + encodeURIComponent(segments[i]);
      }

      return result + (path.charAt(path.length - 1) == '/' ? '/' : '');
    };



    $.pincette.util.url.extractParameters = function(queryString, decode)
    {
      var parameters = queryString.split('&');
      var result = {};

      for (var i = 0; i < parameters.length; ++i)
      {
        var parts = parameters[i].split('=');

        if (!result[parts[0]])
        {
          result[parts[0]] = [];
        }

        result[parts[0]].push
        (
          parts[1] ?
            (
              decode ?
                decodeURIComponent(parts[1].replace(/\+/g, ' ')) :
                parts[1]
            ) : ''
        );
      }

      return result;
    };



    $.pincette.util.url.getEncodedPath = function(url)
    {
      var result =
        $.pincette.util.url.encodeUriPath($.pincette.util.url.getPath(url));

      return result;
    };



    $.pincette.util.url.getParameters = function(url)
    {
      var index = url.indexOf('?');
      var result =
        index == -1 ?
        {} :
        $.pincette.util.url.extractParameters(url.substring(index + 1), true);

      return result;
    };



    $.pincette.util.url.getParts = function(url)
    {
      var matches = urlPattern.exec(url);

      if (matches === null || matches.index !== 0)
      {
        return null;
      }

      var result = {};

      result.scheme = decodeURIComponent(matches[1]);
      result.userInfo = decodeURIComponent(matches[4]);
      result.host = decodeURIComponent(matches[5]);
      result.port = matches[6];
      result.path = decodeURIComponent(matches[7]);
      result.query = decodeURIComponent(matches[9]);
      result.fragment = decodeURIComponent(matches[11]);

      return result;
    };



    $.pincette.util.url.getPath = function(url)
    {
      var parts = $.pincette.util.url.getParts(url);
      var result = parts === null ? decodeURIComponent(url) : parts.path;

      return result;
    };



    $.pincette.util.url.getRootUrl = function(url)
    {
      var root =
        url.indexOf('http://') === 0 || url.indexOf('feed://') === 0 ?
          url.substring(0, url.indexOf('/', 7) + 1) :
          (
            url.indexOf('https://') === 0 ?
              url.substring(0, url.indexOf('/', 8) + 1) : url
          );

      return root;
    };



    $.pincette.util.url.isCollection = function(url)
    {
      var result = url.length > 0 && url.charAt(url.length - 1) == '/';

      return result;
    };



    $.pincette.util.url.isUrl = function(url)
    {
      var result = $.pincette.util.url.getParts(url) !== null;

      return result;
    };



    $.pincette.util.url.resolveUrl = function(parentUrl, url)
    {
      var rootUrl = $.pincette.util.url.getRootUrl(parentUrl);
      var result =
        url.indexOf('http://') === 0 || url.indexOf('https://') === 0  ||
          url.indexOf('feed://') === 0 ?
          url :
          (
            url.charAt(0) == '/' ?
              (
                (
                  $.pincette.util.url.isUrl(rootUrl) ?
                    (
                      rootUrl.charAt(rootUrl.length - 1) == '/' ?
                        rootUrl.substring(0, rootUrl.length - 1) : rootUrl
                    ) : ''
                ) + url
              ) :
              (
                (
                  parentUrl.charAt(parentUrl.length - 1) == '/' ?
                    parentUrl :
                    parentUrl.substring(0, parentUrl.lastIndexOf('/') + 1)
                ) + url
              )
          );

      return result;
    };



    $.pincette.util.url.setParameters = function(url, parameters)
    {
      var index = url.indexOf('?');
      var result = index != -1 ? url.substring(0, index) : url;

      result += '?';

      var first = true;

      for (var name in parameters)
      {
        if (parameters.hasOwnProperty(name))
        {
          for (var i = 0; i < parameters[name].length; ++i)
          {
            if (!first)
            {
              result += '&';
            }
            else
            {
              first = false;
            }

            result += name + '=' + encodeURIComponent(parameters[name][i]);
          }
        }
      }

      if (first)
      {
        result = result.substring(0, result.length - 1);
      }

      return result;
    };



    if (typeof String.prototype.trim !== 'function')
    {
      String.prototype.trim =
        function(){return this.replace(/^\s+|\s+$/g, '');};
    }



    var lowerCaseLetters =
      {
'\u0061':true,'\u0062':true,'\u0063':true,'\u0064':true,
'\u0065':true,'\u0066':true,'\u0067':true,'\u0068':true,
'\u0069':true,'\u006a':true,'\u006b':true,'\u006c':true,
'\u006d':true,'\u006e':true,'\u006f':true,'\u0070':true,
'\u0071':true,'\u0072':true,'\u0073':true,'\u0074':true,
'\u0075':true,'\u0076':true,'\u0077':true,'\u0078':true,
'\u0079':true,'\u007a':true,'\u00b5':true,'\u00df':true,
'\u00e0':true,'\u00e1':true,'\u00e2':true,'\u00e3':true,
'\u00e4':true,'\u00e5':true,'\u00e6':true,'\u00e7':true,
'\u00e8':true,'\u00e9':true,'\u00ea':true,'\u00eb':true,
'\u00ec':true,'\u00ed':true,'\u00ee':true,'\u00ef':true,
'\u00f0':true,'\u00f1':true,'\u00f2':true,'\u00f3':true,
'\u00f4':true,'\u00f5':true,'\u00f6':true,'\u00f8':true,
'\u00f9':true,'\u00fa':true,'\u00fb':true,'\u00fc':true,
'\u00fd':true,'\u00fe':true,'\u00ff':true,'\u0101':true,
'\u0103':true,'\u0105':true,'\u0107':true,'\u0109':true,
'\u010b':true,'\u010d':true,'\u010f':true,'\u0111':true,
'\u0113':true,'\u0115':true,'\u0117':true,'\u0119':true,
'\u011b':true,'\u011d':true,'\u011f':true,'\u0121':true,
'\u0123':true,'\u0125':true,'\u0127':true,'\u0129':true,
'\u012b':true,'\u012d':true,'\u012f':true,'\u0131':true,
'\u0133':true,'\u0135':true,'\u0137':true,'\u0138':true,
'\u013a':true,'\u013c':true,'\u013e':true,'\u0140':true,
'\u0142':true,'\u0144':true,'\u0146':true,'\u0148':true,
'\u0149':true,'\u014b':true,'\u014d':true,'\u014f':true,
'\u0151':true,'\u0153':true,'\u0155':true,'\u0157':true,
'\u0159':true,'\u015b':true,'\u015d':true,'\u015f':true,
'\u0161':true,'\u0163':true,'\u0165':true,'\u0167':true,
'\u0169':true,'\u016b':true,'\u016d':true,'\u016f':true,
'\u0171':true,'\u0173':true,'\u0175':true,'\u0177':true,
'\u017a':true,'\u017c':true,'\u017e':true,'\u017f':true,
'\u0180':true,'\u0183':true,'\u0185':true,'\u0188':true,
'\u018c':true,'\u018d':true,'\u0192':true,'\u0195':true,
'\u0199':true,'\u019a':true,'\u019b':true,'\u019e':true,
'\u01a1':true,'\u01a3':true,'\u01a5':true,'\u01a8':true,
'\u01aa':true,'\u01ab':true,'\u01ad':true,'\u01b0':true,
'\u01b4':true,'\u01b6':true,'\u01b9':true,'\u01ba':true,
'\u01bd':true,'\u01be':true,'\u01bf':true,'\u01c6':true,
'\u01c9':true,'\u01cc':true,'\u01ce':true,'\u01d0':true,
'\u01d2':true,'\u01d4':true,'\u01d6':true,'\u01d8':true,
'\u01da':true,'\u01dc':true,'\u01dd':true,'\u01df':true,
'\u01e1':true,'\u01e3':true,'\u01e5':true,'\u01e7':true,
'\u01e9':true,'\u01eb':true,'\u01ed':true,'\u01ef':true,
'\u01f0':true,'\u01f3':true,'\u01f5':true,'\u01f9':true,
'\u01fb':true,'\u01fd':true,'\u01ff':true,'\u0201':true,
'\u0203':true,'\u0205':true,'\u0207':true,'\u0209':true,
'\u020b':true,'\u020d':true,'\u020f':true,'\u0211':true,
'\u0213':true,'\u0215':true,'\u0217':true,'\u0219':true,
'\u021b':true,'\u021d':true,'\u021f':true,'\u0221':true,
'\u0223':true,'\u0225':true,'\u0227':true,'\u0229':true,
'\u022b':true,'\u022d':true,'\u022f':true,'\u0231':true,
'\u0233':true,'\u0234':true,'\u0235':true,'\u0236':true,
'\u0237':true,'\u0238':true,'\u0239':true,'\u023c':true,
'\u023f':true,'\u0240':true,'\u0242':true,'\u0247':true,
'\u0249':true,'\u024b':true,'\u024d':true,'\u024f':true,
'\u0250':true,'\u0251':true,'\u0252':true,'\u0253':true,
'\u0254':true,'\u0255':true,'\u0256':true,'\u0257':true,
'\u0258':true,'\u0259':true,'\u025a':true,'\u025b':true,
'\u025c':true,'\u025d':true,'\u025e':true,'\u025f':true,
'\u0260':true,'\u0261':true,'\u0262':true,'\u0263':true,
'\u0264':true,'\u0265':true,'\u0266':true,'\u0267':true,
'\u0268':true,'\u0269':true,'\u026a':true,'\u026b':true,
'\u026c':true,'\u026d':true,'\u026e':true,'\u026f':true,
'\u0270':true,'\u0271':true,'\u0272':true,'\u0273':true,
'\u0274':true,'\u0275':true,'\u0276':true,'\u0277':true,
'\u0278':true,'\u0279':true,'\u027a':true,'\u027b':true,
'\u027c':true,'\u027d':true,'\u027e':true,'\u027f':true,
'\u0280':true,'\u0281':true,'\u0282':true,'\u0283':true,
'\u0284':true,'\u0285':true,'\u0286':true,'\u0287':true,
'\u0288':true,'\u0289':true,'\u028a':true,'\u028b':true,
'\u028c':true,'\u028d':true,'\u028e':true,'\u028f':true,
'\u0290':true,'\u0291':true,'\u0292':true,'\u0293':true,
'\u0295':true,'\u0296':true,'\u0297':true,'\u0298':true,
'\u0299':true,'\u029a':true,'\u029b':true,'\u029c':true,
'\u029d':true,'\u029e':true,'\u029f':true,'\u02a0':true,
'\u02a1':true,'\u02a2':true,'\u02a3':true,'\u02a4':true,
'\u02a5':true,'\u02a6':true,'\u02a7':true,'\u02a8':true,
'\u02a9':true,'\u02aa':true,'\u02ab':true,'\u02ac':true,
'\u02ad':true,'\u02ae':true,'\u02af':true,'\u0371':true,
'\u0373':true,'\u0377':true,'\u037b':true,'\u037c':true,
'\u037d':true,'\u0390':true,'\u03ac':true,'\u03ad':true,
'\u03ae':true,'\u03af':true,'\u03b0':true,'\u03b1':true,
'\u03b2':true,'\u03b3':true,'\u03b4':true,'\u03b5':true,
'\u03b6':true,'\u03b7':true,'\u03b8':true,'\u03b9':true,
'\u03ba':true,'\u03bb':true,'\u03bc':true,'\u03bd':true,
'\u03be':true,'\u03bf':true,'\u03c0':true,'\u03c1':true,
'\u03c2':true,'\u03c3':true,'\u03c4':true,'\u03c5':true,
'\u03c6':true,'\u03c7':true,'\u03c8':true,'\u03c9':true,
'\u03ca':true,'\u03cb':true,'\u03cc':true,'\u03cd':true,
'\u03ce':true,'\u03d0':true,'\u03d1':true,'\u03d5':true,
'\u03d6':true,'\u03d7':true,'\u03d9':true,'\u03db':true,
'\u03dd':true,'\u03df':true,'\u03e1':true,'\u03e3':true,
'\u03e5':true,'\u03e7':true,'\u03e9':true,'\u03eb':true,
'\u03ed':true,'\u03ef':true,'\u03f0':true,'\u03f1':true,
'\u03f2':true,'\u03f3':true,'\u03f5':true,'\u03f8':true,
'\u03fb':true,'\u03fc':true,'\u0430':true,'\u0431':true,
'\u0432':true,'\u0433':true,'\u0434':true,'\u0435':true,
'\u0436':true,'\u0437':true,'\u0438':true,'\u0439':true,
'\u043a':true,'\u043b':true,'\u043c':true,'\u043d':true,
'\u043e':true,'\u043f':true,'\u0440':true,'\u0441':true,
'\u0442':true,'\u0443':true,'\u0444':true,'\u0445':true,
'\u0446':true,'\u0447':true,'\u0448':true,'\u0449':true,
'\u044a':true,'\u044b':true,'\u044c':true,'\u044d':true,
'\u044e':true,'\u044f':true,'\u0450':true,'\u0451':true,
'\u0452':true,'\u0453':true,'\u0454':true,'\u0455':true,
'\u0456':true,'\u0457':true,'\u0458':true,'\u0459':true,
'\u045a':true,'\u045b':true,'\u045c':true,'\u045d':true,
'\u045e':true,'\u045f':true,'\u0461':true,'\u0463':true,
'\u0465':true,'\u0467':true,'\u0469':true,'\u046b':true,
'\u046d':true,'\u046f':true,'\u0471':true,'\u0473':true,
'\u0475':true,'\u0477':true,'\u0479':true,'\u047b':true,
'\u047d':true,'\u047f':true,'\u0481':true,'\u048b':true,
'\u048d':true,'\u048f':true,'\u0491':true,'\u0493':true,
'\u0495':true,'\u0497':true,'\u0499':true,'\u049b':true,
'\u049d':true,'\u049f':true,'\u04a1':true,'\u04a3':true,
'\u04a5':true,'\u04a7':true,'\u04a9':true,'\u04ab':true,
'\u04ad':true,'\u04af':true,'\u04b1':true,'\u04b3':true,
'\u04b5':true,'\u04b7':true,'\u04b9':true,'\u04bb':true,
'\u04bd':true,'\u04bf':true,'\u04c2':true,'\u04c4':true,
'\u04c6':true,'\u04c8':true,'\u04ca':true,'\u04cc':true,
'\u04ce':true,'\u04cf':true,'\u04d1':true,'\u04d3':true,
'\u04d5':true,'\u04d7':true,'\u04d9':true,'\u04db':true,
'\u04dd':true,'\u04df':true,'\u04e1':true,'\u04e3':true,
'\u04e5':true,'\u04e7':true,'\u04e9':true,'\u04eb':true,
'\u04ed':true,'\u04ef':true,'\u04f1':true,'\u04f3':true,
'\u04f5':true,'\u04f7':true,'\u04f9':true,'\u04fb':true,
'\u04fd':true,'\u04ff':true,'\u0501':true,'\u0503':true,
'\u0505':true,'\u0507':true,'\u0509':true,'\u050b':true,
'\u050d':true,'\u050f':true,'\u0511':true,'\u0513':true,
'\u0515':true,'\u0517':true,'\u0519':true,'\u051b':true,
'\u051d':true,'\u051f':true,'\u0521':true,'\u0523':true,
'\u0525':true,'\u0527':true,'\u0561':true,'\u0562':true,
'\u0563':true,'\u0564':true,'\u0565':true,'\u0566':true,
'\u0567':true,'\u0568':true,'\u0569':true,'\u056a':true,
'\u056b':true,'\u056c':true,'\u056d':true,'\u056e':true,
'\u056f':true,'\u0570':true,'\u0571':true,'\u0572':true,
'\u0573':true,'\u0574':true,'\u0575':true,'\u0576':true,
'\u0577':true,'\u0578':true,'\u0579':true,'\u057a':true,
'\u057b':true,'\u057c':true,'\u057d':true,'\u057e':true,
'\u057f':true,'\u0580':true,'\u0581':true,'\u0582':true,
'\u0583':true,'\u0584':true,'\u0585':true,'\u0586':true,
'\u0587':true,'\u1d00':true,'\u1d01':true,'\u1d02':true,
'\u1d03':true,'\u1d04':true,'\u1d05':true,'\u1d06':true,
'\u1d07':true,'\u1d08':true,'\u1d09':true,'\u1d0a':true,
'\u1d0b':true,'\u1d0c':true,'\u1d0d':true,'\u1d0e':true,
'\u1d0f':true,'\u1d10':true,'\u1d11':true,'\u1d12':true,
'\u1d13':true,'\u1d14':true,'\u1d15':true,'\u1d16':true,
'\u1d17':true,'\u1d18':true,'\u1d19':true,'\u1d1a':true,
'\u1d1b':true,'\u1d1c':true,'\u1d1d':true,'\u1d1e':true,
'\u1d1f':true,'\u1d20':true,'\u1d21':true,'\u1d22':true,
'\u1d23':true,'\u1d24':true,'\u1d25':true,'\u1d26':true,
'\u1d27':true,'\u1d28':true,'\u1d29':true,'\u1d2a':true,
'\u1d2b':true,'\u1d6b':true,'\u1d6c':true,'\u1d6d':true,
'\u1d6e':true,'\u1d6f':true,'\u1d70':true,'\u1d71':true,
'\u1d72':true,'\u1d73':true,'\u1d74':true,'\u1d75':true,
'\u1d76':true,'\u1d77':true,'\u1d79':true,'\u1d7a':true,
'\u1d7b':true,'\u1d7c':true,'\u1d7d':true,'\u1d7e':true,
'\u1d7f':true,'\u1d80':true,'\u1d81':true,'\u1d82':true,
'\u1d83':true,'\u1d84':true,'\u1d85':true,'\u1d86':true,
'\u1d87':true,'\u1d88':true,'\u1d89':true,'\u1d8a':true,
'\u1d8b':true,'\u1d8c':true,'\u1d8d':true,'\u1d8e':true,
'\u1d8f':true,'\u1d90':true,'\u1d91':true,'\u1d92':true,
'\u1d93':true,'\u1d94':true,'\u1d95':true,'\u1d96':true,
'\u1d97':true,'\u1d98':true,'\u1d99':true,'\u1d9a':true,
'\u1e01':true,'\u1e03':true,'\u1e05':true,'\u1e07':true,
'\u1e09':true,'\u1e0b':true,'\u1e0d':true,'\u1e0f':true,
'\u1e11':true,'\u1e13':true,'\u1e15':true,'\u1e17':true,
'\u1e19':true,'\u1e1b':true,'\u1e1d':true,'\u1e1f':true,
'\u1e21':true,'\u1e23':true,'\u1e25':true,'\u1e27':true,
'\u1e29':true,'\u1e2b':true,'\u1e2d':true,'\u1e2f':true,
'\u1e31':true,'\u1e33':true,'\u1e35':true,'\u1e37':true,
'\u1e39':true,'\u1e3b':true,'\u1e3d':true,'\u1e3f':true,
'\u1e41':true,'\u1e43':true,'\u1e45':true,'\u1e47':true,
'\u1e49':true,'\u1e4b':true,'\u1e4d':true,'\u1e4f':true,
'\u1e51':true,'\u1e53':true,'\u1e55':true,'\u1e57':true,
'\u1e59':true,'\u1e5b':true,'\u1e5d':true,'\u1e5f':true,
'\u1e61':true,'\u1e63':true,'\u1e65':true,'\u1e67':true,
'\u1e69':true,'\u1e6b':true,'\u1e6d':true,'\u1e6f':true,
'\u1e71':true,'\u1e73':true,'\u1e75':true,'\u1e77':true,
'\u1e79':true,'\u1e7b':true,'\u1e7d':true,'\u1e7f':true,
'\u1e81':true,'\u1e83':true,'\u1e85':true,'\u1e87':true,
'\u1e89':true,'\u1e8b':true,'\u1e8d':true,'\u1e8f':true,
'\u1e91':true,'\u1e93':true,'\u1e95':true,'\u1e96':true,
'\u1e97':true,'\u1e98':true,'\u1e99':true,'\u1e9a':true,
'\u1e9b':true,'\u1e9c':true,'\u1e9d':true,'\u1e9f':true,
'\u1ea1':true,'\u1ea3':true,'\u1ea5':true,'\u1ea7':true,
'\u1ea9':true,'\u1eab':true,'\u1ead':true,'\u1eaf':true,
'\u1eb1':true,'\u1eb3':true,'\u1eb5':true,'\u1eb7':true,
'\u1eb9':true,'\u1ebb':true,'\u1ebd':true,'\u1ebf':true,
'\u1ec1':true,'\u1ec3':true,'\u1ec5':true,'\u1ec7':true,
'\u1ec9':true,'\u1ecb':true,'\u1ecd':true,'\u1ecf':true,
'\u1ed1':true,'\u1ed3':true,'\u1ed5':true,'\u1ed7':true,
'\u1ed9':true,'\u1edb':true,'\u1edd':true,'\u1edf':true,
'\u1ee1':true,'\u1ee3':true,'\u1ee5':true,'\u1ee7':true,
'\u1ee9':true,'\u1eeb':true,'\u1eed':true,'\u1eef':true,
'\u1ef1':true,'\u1ef3':true,'\u1ef5':true,'\u1ef7':true,
'\u1ef9':true,'\u1efb':true,'\u1efd':true,'\u1eff':true,
'\u1f00':true,'\u1f01':true,'\u1f02':true,'\u1f03':true,
'\u1f04':true,'\u1f05':true,'\u1f06':true,'\u1f07':true,
'\u1f10':true,'\u1f11':true,'\u1f12':true,'\u1f13':true,
'\u1f14':true,'\u1f15':true,'\u1f20':true,'\u1f21':true,
'\u1f22':true,'\u1f23':true,'\u1f24':true,'\u1f25':true,
'\u1f26':true,'\u1f27':true,'\u1f30':true,'\u1f31':true,
'\u1f32':true,'\u1f33':true,'\u1f34':true,'\u1f35':true,
'\u1f36':true,'\u1f37':true,'\u1f40':true,'\u1f41':true,
'\u1f42':true,'\u1f43':true,'\u1f44':true,'\u1f45':true,
'\u1f50':true,'\u1f51':true,'\u1f52':true,'\u1f53':true,
'\u1f54':true,'\u1f55':true,'\u1f56':true,'\u1f57':true,
'\u1f60':true,'\u1f61':true,'\u1f62':true,'\u1f63':true,
'\u1f64':true,'\u1f65':true,'\u1f66':true,'\u1f67':true,
'\u1f70':true,'\u1f71':true,'\u1f72':true,'\u1f73':true,
'\u1f74':true,'\u1f75':true,'\u1f76':true,'\u1f77':true,
'\u1f78':true,'\u1f79':true,'\u1f7a':true,'\u1f7b':true,
'\u1f7c':true,'\u1f7d':true,'\u1f80':true,'\u1f81':true,
'\u1f82':true,'\u1f83':true,'\u1f84':true,'\u1f85':true,
'\u1f86':true,'\u1f87':true,'\u1f90':true,'\u1f91':true,
'\u1f92':true,'\u1f93':true,'\u1f94':true,'\u1f95':true,
'\u1f96':true,'\u1f97':true,'\u1fa0':true,'\u1fa1':true,
'\u1fa2':true,'\u1fa3':true,'\u1fa4':true,'\u1fa5':true,
'\u1fa6':true,'\u1fa7':true,'\u1fb0':true,'\u1fb1':true,
'\u1fb2':true,'\u1fb3':true,'\u1fb4':true,'\u1fb6':true,
'\u1fb7':true,'\u1fbe':true,'\u1fc2':true,'\u1fc3':true,
'\u1fc4':true,'\u1fc6':true,'\u1fc7':true,'\u1fd0':true,
'\u1fd1':true,'\u1fd2':true,'\u1fd3':true,'\u1fd6':true,
'\u1fd7':true,'\u1fe0':true,'\u1fe1':true,'\u1fe2':true,
'\u1fe3':true,'\u1fe4':true,'\u1fe5':true,'\u1fe6':true,
'\u1fe7':true,'\u1ff2':true,'\u1ff3':true,'\u1ff4':true,
'\u1ff6':true,'\u1ff7':true,'\u210a':true,'\u210e':true,
'\u210f':true,'\u2113':true,'\u212f':true,'\u2134':true,
'\u2139':true,'\u213c':true,'\u213d':true,'\u2146':true,
'\u2147':true,'\u2148':true,'\u2149':true,'\u214e':true,
'\u2184':true,'\u2c30':true,'\u2c31':true,'\u2c32':true,
'\u2c33':true,'\u2c34':true,'\u2c35':true,'\u2c36':true,
'\u2c37':true,'\u2c38':true,'\u2c39':true,'\u2c3a':true,
'\u2c3b':true,'\u2c3c':true,'\u2c3d':true,'\u2c3e':true,
'\u2c3f':true,'\u2c40':true,'\u2c41':true,'\u2c42':true,
'\u2c43':true,'\u2c44':true,'\u2c45':true,'\u2c46':true,
'\u2c47':true,'\u2c48':true,'\u2c49':true,'\u2c4a':true,
'\u2c4b':true,'\u2c4c':true,'\u2c4d':true,'\u2c4e':true,
'\u2c4f':true,'\u2c50':true,'\u2c51':true,'\u2c52':true,
'\u2c53':true,'\u2c54':true,'\u2c55':true,'\u2c56':true,
'\u2c57':true,'\u2c58':true,'\u2c59':true,'\u2c5a':true,
'\u2c5b':true,'\u2c5c':true,'\u2c5d':true,'\u2c5e':true,
'\u2c61':true,'\u2c65':true,'\u2c66':true,'\u2c68':true,
'\u2c6a':true,'\u2c6c':true,'\u2c71':true,'\u2c73':true,
'\u2c74':true,'\u2c76':true,'\u2c77':true,'\u2c78':true,
'\u2c79':true,'\u2c7a':true,'\u2c7b':true,'\u2c81':true,
'\u2c83':true,'\u2c85':true,'\u2c87':true,'\u2c89':true,
'\u2c8b':true,'\u2c8d':true,'\u2c8f':true,'\u2c91':true,
'\u2c93':true,'\u2c95':true,'\u2c97':true,'\u2c99':true,
'\u2c9b':true,'\u2c9d':true,'\u2c9f':true,'\u2ca1':true,
'\u2ca3':true,'\u2ca5':true,'\u2ca7':true,'\u2ca9':true,
'\u2cab':true,'\u2cad':true,'\u2caf':true,'\u2cb1':true,
'\u2cb3':true,'\u2cb5':true,'\u2cb7':true,'\u2cb9':true,
'\u2cbb':true,'\u2cbd':true,'\u2cbf':true,'\u2cc1':true,
'\u2cc3':true,'\u2cc5':true,'\u2cc7':true,'\u2cc9':true,
'\u2ccb':true,'\u2ccd':true,'\u2ccf':true,'\u2cd1':true,
'\u2cd3':true,'\u2cd5':true,'\u2cd7':true,'\u2cd9':true,
'\u2cdb':true,'\u2cdd':true,'\u2cdf':true,'\u2ce1':true,
'\u2ce3':true,'\u2ce4':true,'\u2cec':true,'\u2cee':true,
'\u2cf3':true,'\u2d00':true,'\u2d01':true,'\u2d02':true,
'\u2d03':true,'\u2d04':true,'\u2d05':true,'\u2d06':true,
'\u2d07':true,'\u2d08':true,'\u2d09':true,'\u2d0a':true,
'\u2d0b':true,'\u2d0c':true,'\u2d0d':true,'\u2d0e':true,
'\u2d0f':true,'\u2d10':true,'\u2d11':true,'\u2d12':true,
'\u2d13':true,'\u2d14':true,'\u2d15':true,'\u2d16':true,
'\u2d17':true,'\u2d18':true,'\u2d19':true,'\u2d1a':true,
'\u2d1b':true,'\u2d1c':true,'\u2d1d':true,'\u2d1e':true,
'\u2d1f':true,'\u2d20':true,'\u2d21':true,'\u2d22':true,
'\u2d23':true,'\u2d24':true,'\u2d25':true,'\u2d27':true,
'\u2d2d':true,'\ua641':true,'\ua643':true,'\ua645':true,
'\ua647':true,'\ua649':true,'\ua64b':true,'\ua64d':true,
'\ua64f':true,'\ua651':true,'\ua653':true,'\ua655':true,
'\ua657':true,'\ua659':true,'\ua65b':true,'\ua65d':true,
'\ua65f':true,'\ua661':true,'\ua663':true,'\ua665':true,
'\ua667':true,'\ua669':true,'\ua66b':true,'\ua66d':true,
'\ua681':true,'\ua683':true,'\ua685':true,'\ua687':true,
'\ua689':true,'\ua68b':true,'\ua68d':true,'\ua68f':true,
'\ua691':true,'\ua693':true,'\ua695':true,'\ua697':true,
'\ua723':true,'\ua725':true,'\ua727':true,'\ua729':true,
'\ua72b':true,'\ua72d':true,'\ua72f':true,'\ua730':true,
'\ua731':true,'\ua733':true,'\ua735':true,'\ua737':true,
'\ua739':true,'\ua73b':true,'\ua73d':true,'\ua73f':true,
'\ua741':true,'\ua743':true,'\ua745':true,'\ua747':true,
'\ua749':true,'\ua74b':true,'\ua74d':true,'\ua74f':true,
'\ua751':true,'\ua753':true,'\ua755':true,'\ua757':true,
'\ua759':true,'\ua75b':true,'\ua75d':true,'\ua75f':true,
'\ua761':true,'\ua763':true,'\ua765':true,'\ua767':true,
'\ua769':true,'\ua76b':true,'\ua76d':true,'\ua76f':true,
'\ua771':true,'\ua772':true,'\ua773':true,'\ua774':true,
'\ua775':true,'\ua776':true,'\ua777':true,'\ua778':true,
'\ua77a':true,'\ua77c':true,'\ua77f':true,'\ua781':true,
'\ua783':true,'\ua785':true,'\ua787':true,'\ua78c':true,
'\ua78e':true,'\ua791':true,'\ua793':true,'\ua7a1':true,
'\ua7a3':true,'\ua7a5':true,'\ua7a7':true,'\ua7a9':true,
'\ua7fa':true,'\ufb00':true,'\ufb01':true,'\ufb02':true,
'\ufb03':true,'\ufb04':true,'\ufb05':true,'\ufb06':true,
'\ufb13':true,'\ufb14':true,'\ufb15':true,'\ufb16':true,
'\ufb17':true,'\uff41':true,'\uff42':true,'\uff43':true,
'\uff44':true,'\uff45':true,'\uff46':true,'\uff47':true,
'\uff48':true,'\uff49':true,'\uff4a':true,'\uff4b':true,
'\uff4c':true,'\uff4d':true,'\uff4e':true,'\uff4f':true,
'\uff50':true,'\uff51':true,'\uff52':true,'\uff53':true,
'\uff54':true,'\uff55':true,'\uff56':true,'\uff57':true,
'\uff58':true,'\uff59':true,'\uff5a':true,'\u10428':true,
'\u10429':true,'\u1042a':true,'\u1042b':true,'\u1042c':true,
'\u1042d':true,'\u1042e':true,'\u1042f':true,'\u10430':true,
'\u10431':true,'\u10432':true,'\u10433':true,'\u10434':true,
'\u10435':true,'\u10436':true,'\u10437':true,'\u10438':true,
'\u10439':true,'\u1043a':true,'\u1043b':true,'\u1043c':true,
'\u1043d':true,'\u1043e':true,'\u1043f':true,'\u10440':true,
'\u10441':true,'\u10442':true,'\u10443':true,'\u10444':true,
'\u10445':true,'\u10446':true,'\u10447':true,'\u10448':true,
'\u10449':true,'\u1044a':true,'\u1044b':true,'\u1044c':true,
'\u1044d':true,'\u1044e':true,'\u1044f':true,'\u1d41a':true,
'\u1d41b':true,'\u1d41c':true,'\u1d41d':true,'\u1d41e':true,
'\u1d41f':true,'\u1d420':true,'\u1d421':true,'\u1d422':true,
'\u1d423':true,'\u1d424':true,'\u1d425':true,'\u1d426':true,
'\u1d427':true,'\u1d428':true,'\u1d429':true,'\u1d42a':true,
'\u1d42b':true,'\u1d42c':true,'\u1d42d':true,'\u1d42e':true,
'\u1d42f':true,'\u1d430':true,'\u1d431':true,'\u1d432':true,
'\u1d433':true,'\u1d44e':true,'\u1d44f':true,'\u1d450':true,
'\u1d451':true,'\u1d452':true,'\u1d453':true,'\u1d454':true,
'\u1d456':true,'\u1d457':true,'\u1d458':true,'\u1d459':true,
'\u1d45a':true,'\u1d45b':true,'\u1d45c':true,'\u1d45d':true,
'\u1d45e':true,'\u1d45f':true,'\u1d460':true,'\u1d461':true,
'\u1d462':true,'\u1d463':true,'\u1d464':true,'\u1d465':true,
'\u1d466':true,'\u1d467':true,'\u1d482':true,'\u1d483':true,
'\u1d484':true,'\u1d485':true,'\u1d486':true,'\u1d487':true,
'\u1d488':true,'\u1d489':true,'\u1d48a':true,'\u1d48b':true,
'\u1d48c':true,'\u1d48d':true,'\u1d48e':true,'\u1d48f':true,
'\u1d490':true,'\u1d491':true,'\u1d492':true,'\u1d493':true,
'\u1d494':true,'\u1d495':true,'\u1d496':true,'\u1d497':true,
'\u1d498':true,'\u1d499':true,'\u1d49a':true,'\u1d49b':true,
'\u1d4b6':true,'\u1d4b7':true,'\u1d4b8':true,'\u1d4b9':true,
'\u1d4bb':true,'\u1d4bd':true,'\u1d4be':true,'\u1d4bf':true,
'\u1d4c0':true,'\u1d4c1':true,'\u1d4c2':true,'\u1d4c3':true,
'\u1d4c5':true,'\u1d4c6':true,'\u1d4c7':true,'\u1d4c8':true,
'\u1d4c9':true,'\u1d4ca':true,'\u1d4cb':true,'\u1d4cc':true,
'\u1d4cd':true,'\u1d4ce':true,'\u1d4cf':true,'\u1d4ea':true,
'\u1d4eb':true,'\u1d4ec':true,'\u1d4ed':true,'\u1d4ee':true,
'\u1d4ef':true,'\u1d4f0':true,'\u1d4f1':true,'\u1d4f2':true,
'\u1d4f3':true,'\u1d4f4':true,'\u1d4f5':true,'\u1d4f6':true,
'\u1d4f7':true,'\u1d4f8':true,'\u1d4f9':true,'\u1d4fa':true,
'\u1d4fb':true,'\u1d4fc':true,'\u1d4fd':true,'\u1d4fe':true,
'\u1d4ff':true,'\u1d500':true,'\u1d501':true,'\u1d502':true,
'\u1d503':true,'\u1d51e':true,'\u1d51f':true,'\u1d520':true,
'\u1d521':true,'\u1d522':true,'\u1d523':true,'\u1d524':true,
'\u1d525':true,'\u1d526':true,'\u1d527':true,'\u1d528':true,
'\u1d529':true,'\u1d52a':true,'\u1d52b':true,'\u1d52c':true,
'\u1d52d':true,'\u1d52e':true,'\u1d52f':true,'\u1d530':true,
'\u1d531':true,'\u1d532':true,'\u1d533':true,'\u1d534':true,
'\u1d535':true,'\u1d536':true,'\u1d537':true,'\u1d552':true,
'\u1d553':true,'\u1d554':true,'\u1d555':true,'\u1d556':true,
'\u1d557':true,'\u1d558':true,'\u1d559':true,'\u1d55a':true,
'\u1d55b':true,'\u1d55c':true,'\u1d55d':true,'\u1d55e':true,
'\u1d55f':true,'\u1d560':true,'\u1d561':true,'\u1d562':true,
'\u1d563':true,'\u1d564':true,'\u1d565':true,'\u1d566':true,
'\u1d567':true,'\u1d568':true,'\u1d569':true,'\u1d56a':true,
'\u1d56b':true,'\u1d586':true,'\u1d587':true,'\u1d588':true,
'\u1d589':true,'\u1d58a':true,'\u1d58b':true,'\u1d58c':true,
'\u1d58d':true,'\u1d58e':true,'\u1d58f':true,'\u1d590':true,
'\u1d591':true,'\u1d592':true,'\u1d593':true,'\u1d594':true,
'\u1d595':true,'\u1d596':true,'\u1d597':true,'\u1d598':true,
'\u1d599':true,'\u1d59a':true,'\u1d59b':true,'\u1d59c':true,
'\u1d59d':true,'\u1d59e':true,'\u1d59f':true,'\u1d5ba':true,
'\u1d5bb':true,'\u1d5bc':true,'\u1d5bd':true,'\u1d5be':true,
'\u1d5bf':true,'\u1d5c0':true,'\u1d5c1':true,'\u1d5c2':true,
'\u1d5c3':true,'\u1d5c4':true,'\u1d5c5':true,'\u1d5c6':true,
'\u1d5c7':true,'\u1d5c8':true,'\u1d5c9':true,'\u1d5ca':true,
'\u1d5cb':true,'\u1d5cc':true,'\u1d5cd':true,'\u1d5ce':true,
'\u1d5cf':true,'\u1d5d0':true,'\u1d5d1':true,'\u1d5d2':true,
'\u1d5d3':true,'\u1d5ee':true,'\u1d5ef':true,'\u1d5f0':true,
'\u1d5f1':true,'\u1d5f2':true,'\u1d5f3':true,'\u1d5f4':true,
'\u1d5f5':true,'\u1d5f6':true,'\u1d5f7':true,'\u1d5f8':true,
'\u1d5f9':true,'\u1d5fa':true,'\u1d5fb':true,'\u1d5fc':true,
'\u1d5fd':true,'\u1d5fe':true,'\u1d5ff':true,'\u1d600':true,
'\u1d601':true,'\u1d602':true,'\u1d603':true,'\u1d604':true,
'\u1d605':true,'\u1d606':true,'\u1d607':true,'\u1d622':true,
'\u1d623':true,'\u1d624':true,'\u1d625':true,'\u1d626':true,
'\u1d627':true,'\u1d628':true,'\u1d629':true,'\u1d62a':true,
'\u1d62b':true,'\u1d62c':true,'\u1d62d':true,'\u1d62e':true,
'\u1d62f':true,'\u1d630':true,'\u1d631':true,'\u1d632':true,
'\u1d633':true,'\u1d634':true,'\u1d635':true,'\u1d636':true,
'\u1d637':true,'\u1d638':true,'\u1d639':true,'\u1d63a':true,
'\u1d63b':true,'\u1d656':true,'\u1d657':true,'\u1d658':true,
'\u1d659':true,'\u1d65a':true,'\u1d65b':true,'\u1d65c':true,
'\u1d65d':true,'\u1d65e':true,'\u1d65f':true,'\u1d660':true,
'\u1d661':true,'\u1d662':true,'\u1d663':true,'\u1d664':true,
'\u1d665':true,'\u1d666':true,'\u1d667':true,'\u1d668':true,
'\u1d669':true,'\u1d66a':true,'\u1d66b':true,'\u1d66c':true,
'\u1d66d':true,'\u1d66e':true,'\u1d66f':true,'\u1d68a':true,
'\u1d68b':true,'\u1d68c':true,'\u1d68d':true,'\u1d68e':true,
'\u1d68f':true,'\u1d690':true,'\u1d691':true,'\u1d692':true,
'\u1d693':true,'\u1d694':true,'\u1d695':true,'\u1d696':true,
'\u1d697':true,'\u1d698':true,'\u1d699':true,'\u1d69a':true,
'\u1d69b':true,'\u1d69c':true,'\u1d69d':true,'\u1d69e':true,
'\u1d69f':true,'\u1d6a0':true,'\u1d6a1':true,'\u1d6a2':true,
'\u1d6a3':true,'\u1d6a4':true,'\u1d6a5':true,'\u1d6c2':true,
'\u1d6c3':true,'\u1d6c4':true,'\u1d6c5':true,'\u1d6c6':true,
'\u1d6c7':true,'\u1d6c8':true,'\u1d6c9':true,'\u1d6ca':true,
'\u1d6cb':true,'\u1d6cc':true,'\u1d6cd':true,'\u1d6ce':true,
'\u1d6cf':true,'\u1d6d0':true,'\u1d6d1':true,'\u1d6d2':true,
'\u1d6d3':true,'\u1d6d4':true,'\u1d6d5':true,'\u1d6d6':true,
'\u1d6d7':true,'\u1d6d8':true,'\u1d6d9':true,'\u1d6da':true,
'\u1d6dc':true,'\u1d6dd':true,'\u1d6de':true,'\u1d6df':true,
'\u1d6e0':true,'\u1d6e1':true,'\u1d6fc':true,'\u1d6fd':true,
'\u1d6fe':true,'\u1d6ff':true,'\u1d700':true,'\u1d701':true,
'\u1d702':true,'\u1d703':true,'\u1d704':true,'\u1d705':true,
'\u1d706':true,'\u1d707':true,'\u1d708':true,'\u1d709':true,
'\u1d70a':true,'\u1d70b':true,'\u1d70c':true,'\u1d70d':true,
'\u1d70e':true,'\u1d70f':true,'\u1d710':true,'\u1d711':true,
'\u1d712':true,'\u1d713':true,'\u1d714':true,'\u1d716':true,
'\u1d717':true,'\u1d718':true,'\u1d719':true,'\u1d71a':true,
'\u1d71b':true,'\u1d736':true,'\u1d737':true,'\u1d738':true,
'\u1d739':true,'\u1d73a':true,'\u1d73b':true,'\u1d73c':true,
'\u1d73d':true,'\u1d73e':true,'\u1d73f':true,'\u1d740':true,
'\u1d741':true,'\u1d742':true,'\u1d743':true,'\u1d744':true,
'\u1d745':true,'\u1d746':true,'\u1d747':true,'\u1d748':true,
'\u1d749':true,'\u1d74a':true,'\u1d74b':true,'\u1d74c':true,
'\u1d74d':true,'\u1d74e':true,'\u1d750':true,'\u1d751':true,
'\u1d752':true,'\u1d753':true,'\u1d754':true,'\u1d755':true,
'\u1d770':true,'\u1d771':true,'\u1d772':true,'\u1d773':true,
'\u1d774':true,'\u1d775':true,'\u1d776':true,'\u1d777':true,
'\u1d778':true,'\u1d779':true,'\u1d77a':true,'\u1d77b':true,
'\u1d77c':true,'\u1d77d':true,'\u1d77e':true,'\u1d77f':true,
'\u1d780':true,'\u1d781':true,'\u1d782':true,'\u1d783':true,
'\u1d784':true,'\u1d785':true,'\u1d786':true,'\u1d787':true,
'\u1d788':true,'\u1d78a':true,'\u1d78b':true,'\u1d78c':true,
'\u1d78d':true,'\u1d78e':true,'\u1d78f':true,'\u1d7aa':true,
'\u1d7ab':true,'\u1d7ac':true,'\u1d7ad':true,'\u1d7ae':true,
'\u1d7af':true,'\u1d7b0':true,'\u1d7b1':true,'\u1d7b2':true,
'\u1d7b3':true,'\u1d7b4':true,'\u1d7b5':true,'\u1d7b6':true,
'\u1d7b7':true,'\u1d7b8':true,'\u1d7b9':true,'\u1d7ba':true,
'\u1d7bb':true,'\u1d7bc':true,'\u1d7bd':true,'\u1d7be':true,
'\u1d7bf':true,'\u1d7c0':true,'\u1d7c1':true,'\u1d7c2':true,
'\u1d7c4':true,'\u1d7c5':true,'\u1d7c6':true,'\u1d7c7':true,
'\u1d7c8':true,'\u1d7c9':true,'\u1d7cb':true
      };

    var upperCaseLetters =
      {
'\u0041':true,'\u0042':true,'\u0043':true,'\u0044':true,
'\u0045':true,'\u0046':true,'\u0047':true,'\u0048':true,
'\u0049':true,'\u004a':true,'\u004b':true,'\u004c':true,
'\u004d':true,'\u004e':true,'\u004f':true,'\u0050':true,
'\u0051':true,'\u0052':true,'\u0053':true,'\u0054':true,
'\u0055':true,'\u0056':true,'\u0057':true,'\u0058':true,
'\u0059':true,'\u005a':true,'\u00c0':true,'\u00c1':true,
'\u00c2':true,'\u00c3':true,'\u00c4':true,'\u00c5':true,
'\u00c6':true,'\u00c7':true,'\u00c8':true,'\u00c9':true,
'\u00ca':true,'\u00cb':true,'\u00cc':true,'\u00cd':true,
'\u00ce':true,'\u00cf':true,'\u00d0':true,'\u00d1':true,
'\u00d2':true,'\u00d3':true,'\u00d4':true,'\u00d5':true,
'\u00d6':true,'\u00d8':true,'\u00d9':true,'\u00da':true,
'\u00db':true,'\u00dc':true,'\u00dd':true,'\u00de':true,
'\u0100':true,'\u0102':true,'\u0104':true,'\u0106':true,
'\u0108':true,'\u010a':true,'\u010c':true,'\u010e':true,
'\u0110':true,'\u0112':true,'\u0114':true,'\u0116':true,
'\u0118':true,'\u011a':true,'\u011c':true,'\u011e':true,
'\u0120':true,'\u0122':true,'\u0124':true,'\u0126':true,
'\u0128':true,'\u012a':true,'\u012c':true,'\u012e':true,
'\u0130':true,'\u0132':true,'\u0134':true,'\u0136':true,
'\u0139':true,'\u013b':true,'\u013d':true,'\u013f':true,
'\u0141':true,'\u0143':true,'\u0145':true,'\u0147':true,
'\u014a':true,'\u014c':true,'\u014e':true,'\u0150':true,
'\u0152':true,'\u0154':true,'\u0156':true,'\u0158':true,
'\u015a':true,'\u015c':true,'\u015e':true,'\u0160':true,
'\u0162':true,'\u0164':true,'\u0166':true,'\u0168':true,
'\u016a':true,'\u016c':true,'\u016e':true,'\u0170':true,
'\u0172':true,'\u0174':true,'\u0176':true,'\u0178':true,
'\u0179':true,'\u017b':true,'\u017d':true,'\u0181':true,
'\u0182':true,'\u0184':true,'\u0186':true,'\u0187':true,
'\u0189':true,'\u018a':true,'\u018b':true,'\u018e':true,
'\u018f':true,'\u0190':true,'\u0191':true,'\u0193':true,
'\u0194':true,'\u0196':true,'\u0197':true,'\u0198':true,
'\u019c':true,'\u019d':true,'\u019f':true,'\u01a0':true,
'\u01a2':true,'\u01a4':true,'\u01a6':true,'\u01a7':true,
'\u01a9':true,'\u01ac':true,'\u01ae':true,'\u01af':true,
'\u01b1':true,'\u01b2':true,'\u01b3':true,'\u01b5':true,
'\u01b7':true,'\u01b8':true,'\u01bc':true,'\u01c4':true,
'\u01c7':true,'\u01ca':true,'\u01cd':true,'\u01cf':true,
'\u01d1':true,'\u01d3':true,'\u01d5':true,'\u01d7':true,
'\u01d9':true,'\u01db':true,'\u01de':true,'\u01e0':true,
'\u01e2':true,'\u01e4':true,'\u01e6':true,'\u01e8':true,
'\u01ea':true,'\u01ec':true,'\u01ee':true,'\u01f1':true,
'\u01f4':true,'\u01f6':true,'\u01f7':true,'\u01f8':true,
'\u01fa':true,'\u01fc':true,'\u01fe':true,'\u0200':true,
'\u0202':true,'\u0204':true,'\u0206':true,'\u0208':true,
'\u020a':true,'\u020c':true,'\u020e':true,'\u0210':true,
'\u0212':true,'\u0214':true,'\u0216':true,'\u0218':true,
'\u021a':true,'\u021c':true,'\u021e':true,'\u0220':true,
'\u0222':true,'\u0224':true,'\u0226':true,'\u0228':true,
'\u022a':true,'\u022c':true,'\u022e':true,'\u0230':true,
'\u0232':true,'\u023a':true,'\u023b':true,'\u023d':true,
'\u023e':true,'\u0241':true,'\u0243':true,'\u0244':true,
'\u0245':true,'\u0246':true,'\u0248':true,'\u024a':true,
'\u024c':true,'\u024e':true,'\u0370':true,'\u0372':true,
'\u0376':true,'\u0386':true,'\u0388':true,'\u0389':true,
'\u038a':true,'\u038c':true,'\u038e':true,'\u038f':true,
'\u0391':true,'\u0392':true,'\u0393':true,'\u0394':true,
'\u0395':true,'\u0396':true,'\u0397':true,'\u0398':true,
'\u0399':true,'\u039a':true,'\u039b':true,'\u039c':true,
'\u039d':true,'\u039e':true,'\u039f':true,'\u03a0':true,
'\u03a1':true,'\u03a3':true,'\u03a4':true,'\u03a5':true,
'\u03a6':true,'\u03a7':true,'\u03a8':true,'\u03a9':true,
'\u03aa':true,'\u03ab':true,'\u03cf':true,'\u03d2':true,
'\u03d3':true,'\u03d4':true,'\u03d8':true,'\u03da':true,
'\u03dc':true,'\u03de':true,'\u03e0':true,'\u03e2':true,
'\u03e4':true,'\u03e6':true,'\u03e8':true,'\u03ea':true,
'\u03ec':true,'\u03ee':true,'\u03f4':true,'\u03f7':true,
'\u03f9':true,'\u03fa':true,'\u03fd':true,'\u03fe':true,
'\u03ff':true,'\u0400':true,'\u0401':true,'\u0402':true,
'\u0403':true,'\u0404':true,'\u0405':true,'\u0406':true,
'\u0407':true,'\u0408':true,'\u0409':true,'\u040a':true,
'\u040b':true,'\u040c':true,'\u040d':true,'\u040e':true,
'\u040f':true,'\u0410':true,'\u0411':true,'\u0412':true,
'\u0413':true,'\u0414':true,'\u0415':true,'\u0416':true,
'\u0417':true,'\u0418':true,'\u0419':true,'\u041a':true,
'\u041b':true,'\u041c':true,'\u041d':true,'\u041e':true,
'\u041f':true,'\u0420':true,'\u0421':true,'\u0422':true,
'\u0423':true,'\u0424':true,'\u0425':true,'\u0426':true,
'\u0427':true,'\u0428':true,'\u0429':true,'\u042a':true,
'\u042b':true,'\u042c':true,'\u042d':true,'\u042e':true,
'\u042f':true,'\u0460':true,'\u0462':true,'\u0464':true,
'\u0466':true,'\u0468':true,'\u046a':true,'\u046c':true,
'\u046e':true,'\u0470':true,'\u0472':true,'\u0474':true,
'\u0476':true,'\u0478':true,'\u047a':true,'\u047c':true,
'\u047e':true,'\u0480':true,'\u048a':true,'\u048c':true,
'\u048e':true,'\u0490':true,'\u0492':true,'\u0494':true,
'\u0496':true,'\u0498':true,'\u049a':true,'\u049c':true,
'\u049e':true,'\u04a0':true,'\u04a2':true,'\u04a4':true,
'\u04a6':true,'\u04a8':true,'\u04aa':true,'\u04ac':true,
'\u04ae':true,'\u04b0':true,'\u04b2':true,'\u04b4':true,
'\u04b6':true,'\u04b8':true,'\u04ba':true,'\u04bc':true,
'\u04be':true,'\u04c0':true,'\u04c1':true,'\u04c3':true,
'\u04c5':true,'\u04c7':true,'\u04c9':true,'\u04cb':true,
'\u04cd':true,'\u04d0':true,'\u04d2':true,'\u04d4':true,
'\u04d6':true,'\u04d8':true,'\u04da':true,'\u04dc':true,
'\u04de':true,'\u04e0':true,'\u04e2':true,'\u04e4':true,
'\u04e6':true,'\u04e8':true,'\u04ea':true,'\u04ec':true,
'\u04ee':true,'\u04f0':true,'\u04f2':true,'\u04f4':true,
'\u04f6':true,'\u04f8':true,'\u04fa':true,'\u04fc':true,
'\u04fe':true,'\u0500':true,'\u0502':true,'\u0504':true,
'\u0506':true,'\u0508':true,'\u050a':true,'\u050c':true,
'\u050e':true,'\u0510':true,'\u0512':true,'\u0514':true,
'\u0516':true,'\u0518':true,'\u051a':true,'\u051c':true,
'\u051e':true,'\u0520':true,'\u0522':true,'\u0524':true,
'\u0526':true,'\u0531':true,'\u0532':true,'\u0533':true,
'\u0534':true,'\u0535':true,'\u0536':true,'\u0537':true,
'\u0538':true,'\u0539':true,'\u053a':true,'\u053b':true,
'\u053c':true,'\u053d':true,'\u053e':true,'\u053f':true,
'\u0540':true,'\u0541':true,'\u0542':true,'\u0543':true,
'\u0544':true,'\u0545':true,'\u0546':true,'\u0547':true,
'\u0548':true,'\u0549':true,'\u054a':true,'\u054b':true,
'\u054c':true,'\u054d':true,'\u054e':true,'\u054f':true,
'\u0550':true,'\u0551':true,'\u0552':true,'\u0553':true,
'\u0554':true,'\u0555':true,'\u0556':true,'\u10a0':true,
'\u10a1':true,'\u10a2':true,'\u10a3':true,'\u10a4':true,
'\u10a5':true,'\u10a6':true,'\u10a7':true,'\u10a8':true,
'\u10a9':true,'\u10aa':true,'\u10ab':true,'\u10ac':true,
'\u10ad':true,'\u10ae':true,'\u10af':true,'\u10b0':true,
'\u10b1':true,'\u10b2':true,'\u10b3':true,'\u10b4':true,
'\u10b5':true,'\u10b6':true,'\u10b7':true,'\u10b8':true,
'\u10b9':true,'\u10ba':true,'\u10bb':true,'\u10bc':true,
'\u10bd':true,'\u10be':true,'\u10bf':true,'\u10c0':true,
'\u10c1':true,'\u10c2':true,'\u10c3':true,'\u10c4':true,
'\u10c5':true,'\u10c7':true,'\u10cd':true,'\u1e00':true,
'\u1e02':true,'\u1e04':true,'\u1e06':true,'\u1e08':true,
'\u1e0a':true,'\u1e0c':true,'\u1e0e':true,'\u1e10':true,
'\u1e12':true,'\u1e14':true,'\u1e16':true,'\u1e18':true,
'\u1e1a':true,'\u1e1c':true,'\u1e1e':true,'\u1e20':true,
'\u1e22':true,'\u1e24':true,'\u1e26':true,'\u1e28':true,
'\u1e2a':true,'\u1e2c':true,'\u1e2e':true,'\u1e30':true,
'\u1e32':true,'\u1e34':true,'\u1e36':true,'\u1e38':true,
'\u1e3a':true,'\u1e3c':true,'\u1e3e':true,'\u1e40':true,
'\u1e42':true,'\u1e44':true,'\u1e46':true,'\u1e48':true,
'\u1e4a':true,'\u1e4c':true,'\u1e4e':true,'\u1e50':true,
'\u1e52':true,'\u1e54':true,'\u1e56':true,'\u1e58':true,
'\u1e5a':true,'\u1e5c':true,'\u1e5e':true,'\u1e60':true,
'\u1e62':true,'\u1e64':true,'\u1e66':true,'\u1e68':true,
'\u1e6a':true,'\u1e6c':true,'\u1e6e':true,'\u1e70':true,
'\u1e72':true,'\u1e74':true,'\u1e76':true,'\u1e78':true,
'\u1e7a':true,'\u1e7c':true,'\u1e7e':true,'\u1e80':true,
'\u1e82':true,'\u1e84':true,'\u1e86':true,'\u1e88':true,
'\u1e8a':true,'\u1e8c':true,'\u1e8e':true,'\u1e90':true,
'\u1e92':true,'\u1e94':true,'\u1e9e':true,'\u1ea0':true,
'\u1ea2':true,'\u1ea4':true,'\u1ea6':true,'\u1ea8':true,
'\u1eaa':true,'\u1eac':true,'\u1eae':true,'\u1eb0':true,
'\u1eb2':true,'\u1eb4':true,'\u1eb6':true,'\u1eb8':true,
'\u1eba':true,'\u1ebc':true,'\u1ebe':true,'\u1ec0':true,
'\u1ec2':true,'\u1ec4':true,'\u1ec6':true,'\u1ec8':true,
'\u1eca':true,'\u1ecc':true,'\u1ece':true,'\u1ed0':true,
'\u1ed2':true,'\u1ed4':true,'\u1ed6':true,'\u1ed8':true,
'\u1eda':true,'\u1edc':true,'\u1ede':true,'\u1ee0':true,
'\u1ee2':true,'\u1ee4':true,'\u1ee6':true,'\u1ee8':true,
'\u1eea':true,'\u1eec':true,'\u1eee':true,'\u1ef0':true,
'\u1ef2':true,'\u1ef4':true,'\u1ef6':true,'\u1ef8':true,
'\u1efa':true,'\u1efc':true,'\u1efe':true,'\u1f08':true,
'\u1f09':true,'\u1f0a':true,'\u1f0b':true,'\u1f0c':true,
'\u1f0d':true,'\u1f0e':true,'\u1f0f':true,'\u1f18':true,
'\u1f19':true,'\u1f1a':true,'\u1f1b':true,'\u1f1c':true,
'\u1f1d':true,'\u1f28':true,'\u1f29':true,'\u1f2a':true,
'\u1f2b':true,'\u1f2c':true,'\u1f2d':true,'\u1f2e':true,
'\u1f2f':true,'\u1f38':true,'\u1f39':true,'\u1f3a':true,
'\u1f3b':true,'\u1f3c':true,'\u1f3d':true,'\u1f3e':true,
'\u1f3f':true,'\u1f48':true,'\u1f49':true,'\u1f4a':true,
'\u1f4b':true,'\u1f4c':true,'\u1f4d':true,'\u1f59':true,
'\u1f5b':true,'\u1f5d':true,'\u1f5f':true,'\u1f68':true,
'\u1f69':true,'\u1f6a':true,'\u1f6b':true,'\u1f6c':true,
'\u1f6d':true,'\u1f6e':true,'\u1f6f':true,'\u1fb8':true,
'\u1fb9':true,'\u1fba':true,'\u1fbb':true,'\u1fc8':true,
'\u1fc9':true,'\u1fca':true,'\u1fcb':true,'\u1fd8':true,
'\u1fd9':true,'\u1fda':true,'\u1fdb':true,'\u1fe8':true,
'\u1fe9':true,'\u1fea':true,'\u1feb':true,'\u1fec':true,
'\u1ff8':true,'\u1ff9':true,'\u1ffa':true,'\u1ffb':true,
'\u2102':true,'\u2107':true,'\u210b':true,'\u210c':true,
'\u210d':true,'\u2110':true,'\u2111':true,'\u2112':true,
'\u2115':true,'\u2119':true,'\u211a':true,'\u211b':true,
'\u211c':true,'\u211d':true,'\u2124':true,'\u2126':true,
'\u2128':true,'\u212a':true,'\u212b':true,'\u212c':true,
'\u212d':true,'\u2130':true,'\u2131':true,'\u2132':true,
'\u2133':true,'\u213e':true,'\u213f':true,'\u2145':true,
'\u2183':true,'\u2c00':true,'\u2c01':true,'\u2c02':true,
'\u2c03':true,'\u2c04':true,'\u2c05':true,'\u2c06':true,
'\u2c07':true,'\u2c08':true,'\u2c09':true,'\u2c0a':true,
'\u2c0b':true,'\u2c0c':true,'\u2c0d':true,'\u2c0e':true,
'\u2c0f':true,'\u2c10':true,'\u2c11':true,'\u2c12':true,
'\u2c13':true,'\u2c14':true,'\u2c15':true,'\u2c16':true,
'\u2c17':true,'\u2c18':true,'\u2c19':true,'\u2c1a':true,
'\u2c1b':true,'\u2c1c':true,'\u2c1d':true,'\u2c1e':true,
'\u2c1f':true,'\u2c20':true,'\u2c21':true,'\u2c22':true,
'\u2c23':true,'\u2c24':true,'\u2c25':true,'\u2c26':true,
'\u2c27':true,'\u2c28':true,'\u2c29':true,'\u2c2a':true,
'\u2c2b':true,'\u2c2c':true,'\u2c2d':true,'\u2c2e':true,
'\u2c60':true,'\u2c62':true,'\u2c63':true,'\u2c64':true,
'\u2c67':true,'\u2c69':true,'\u2c6b':true,'\u2c6d':true,
'\u2c6e':true,'\u2c6f':true,'\u2c70':true,'\u2c72':true,
'\u2c75':true,'\u2c7e':true,'\u2c7f':true,'\u2c80':true,
'\u2c82':true,'\u2c84':true,'\u2c86':true,'\u2c88':true,
'\u2c8a':true,'\u2c8c':true,'\u2c8e':true,'\u2c90':true,
'\u2c92':true,'\u2c94':true,'\u2c96':true,'\u2c98':true,
'\u2c9a':true,'\u2c9c':true,'\u2c9e':true,'\u2ca0':true,
'\u2ca2':true,'\u2ca4':true,'\u2ca6':true,'\u2ca8':true,
'\u2caa':true,'\u2cac':true,'\u2cae':true,'\u2cb0':true,
'\u2cb2':true,'\u2cb4':true,'\u2cb6':true,'\u2cb8':true,
'\u2cba':true,'\u2cbc':true,'\u2cbe':true,'\u2cc0':true,
'\u2cc2':true,'\u2cc4':true,'\u2cc6':true,'\u2cc8':true,
'\u2cca':true,'\u2ccc':true,'\u2cce':true,'\u2cd0':true,
'\u2cd2':true,'\u2cd4':true,'\u2cd6':true,'\u2cd8':true,
'\u2cda':true,'\u2cdc':true,'\u2cde':true,'\u2ce0':true,
'\u2ce2':true,'\u2ceb':true,'\u2ced':true,'\u2cf2':true,
'\ua640':true,'\ua642':true,'\ua644':true,'\ua646':true,
'\ua648':true,'\ua64a':true,'\ua64c':true,'\ua64e':true,
'\ua650':true,'\ua652':true,'\ua654':true,'\ua656':true,
'\ua658':true,'\ua65a':true,'\ua65c':true,'\ua65e':true,
'\ua660':true,'\ua662':true,'\ua664':true,'\ua666':true,
'\ua668':true,'\ua66a':true,'\ua66c':true,'\ua680':true,
'\ua682':true,'\ua684':true,'\ua686':true,'\ua688':true,
'\ua68a':true,'\ua68c':true,'\ua68e':true,'\ua690':true,
'\ua692':true,'\ua694':true,'\ua696':true,'\ua722':true,
'\ua724':true,'\ua726':true,'\ua728':true,'\ua72a':true,
'\ua72c':true,'\ua72e':true,'\ua732':true,'\ua734':true,
'\ua736':true,'\ua738':true,'\ua73a':true,'\ua73c':true,
'\ua73e':true,'\ua740':true,'\ua742':true,'\ua744':true,
'\ua746':true,'\ua748':true,'\ua74a':true,'\ua74c':true,
'\ua74e':true,'\ua750':true,'\ua752':true,'\ua754':true,
'\ua756':true,'\ua758':true,'\ua75a':true,'\ua75c':true,
'\ua75e':true,'\ua760':true,'\ua762':true,'\ua764':true,
'\ua766':true,'\ua768':true,'\ua76a':true,'\ua76c':true,
'\ua76e':true,'\ua779':true,'\ua77b':true,'\ua77d':true,
'\ua77e':true,'\ua780':true,'\ua782':true,'\ua784':true,
'\ua786':true,'\ua78b':true,'\ua78d':true,'\ua790':true,
'\ua792':true,'\ua7a0':true,'\ua7a2':true,'\ua7a4':true,
'\ua7a6':true,'\ua7a8':true,'\ua7aa':true,'\uff21':true,
'\uff22':true,'\uff23':true,'\uff24':true,'\uff25':true,
'\uff26':true,'\uff27':true,'\uff28':true,'\uff29':true,
'\uff2a':true,'\uff2b':true,'\uff2c':true,'\uff2d':true,
'\uff2e':true,'\uff2f':true,'\uff30':true,'\uff31':true,
'\uff32':true,'\uff33':true,'\uff34':true,'\uff35':true,
'\uff36':true,'\uff37':true,'\uff38':true,'\uff39':true,
'\uff3a':true,'\u10400':true,'\u10401':true,'\u10402':true,
'\u10403':true,'\u10404':true,'\u10405':true,'\u10406':true,
'\u10407':true,'\u10408':true,'\u10409':true,'\u1040a':true,
'\u1040b':true,'\u1040c':true,'\u1040d':true,'\u1040e':true,
'\u1040f':true,'\u10410':true,'\u10411':true,'\u10412':true,
'\u10413':true,'\u10414':true,'\u10415':true,'\u10416':true,
'\u10417':true,'\u10418':true,'\u10419':true,'\u1041a':true,
'\u1041b':true,'\u1041c':true,'\u1041d':true,'\u1041e':true,
'\u1041f':true,'\u10420':true,'\u10421':true,'\u10422':true,
'\u10423':true,'\u10424':true,'\u10425':true,'\u10426':true,
'\u10427':true,'\u1d400':true,'\u1d401':true,'\u1d402':true,
'\u1d403':true,'\u1d404':true,'\u1d405':true,'\u1d406':true,
'\u1d407':true,'\u1d408':true,'\u1d409':true,'\u1d40a':true,
'\u1d40b':true,'\u1d40c':true,'\u1d40d':true,'\u1d40e':true,
'\u1d40f':true,'\u1d410':true,'\u1d411':true,'\u1d412':true,
'\u1d413':true,'\u1d414':true,'\u1d415':true,'\u1d416':true,
'\u1d417':true,'\u1d418':true,'\u1d419':true,'\u1d434':true,
'\u1d435':true,'\u1d436':true,'\u1d437':true,'\u1d438':true,
'\u1d439':true,'\u1d43a':true,'\u1d43b':true,'\u1d43c':true,
'\u1d43d':true,'\u1d43e':true,'\u1d43f':true,'\u1d440':true,
'\u1d441':true,'\u1d442':true,'\u1d443':true,'\u1d444':true,
'\u1d445':true,'\u1d446':true,'\u1d447':true,'\u1d448':true,
'\u1d449':true,'\u1d44a':true,'\u1d44b':true,'\u1d44c':true,
'\u1d44d':true,'\u1d468':true,'\u1d469':true,'\u1d46a':true,
'\u1d46b':true,'\u1d46c':true,'\u1d46d':true,'\u1d46e':true,
'\u1d46f':true,'\u1d470':true,'\u1d471':true,'\u1d472':true,
'\u1d473':true,'\u1d474':true,'\u1d475':true,'\u1d476':true,
'\u1d477':true,'\u1d478':true,'\u1d479':true,'\u1d47a':true,
'\u1d47b':true,'\u1d47c':true,'\u1d47d':true,'\u1d47e':true,
'\u1d47f':true,'\u1d480':true,'\u1d481':true,'\u1d49c':true,
'\u1d49e':true,'\u1d49f':true,'\u1d4a2':true,'\u1d4a5':true,
'\u1d4a6':true,'\u1d4a9':true,'\u1d4aa':true,'\u1d4ab':true,
'\u1d4ac':true,'\u1d4ae':true,'\u1d4af':true,'\u1d4b0':true,
'\u1d4b1':true,'\u1d4b2':true,'\u1d4b3':true,'\u1d4b4':true,
'\u1d4b5':true,'\u1d4d0':true,'\u1d4d1':true,'\u1d4d2':true,
'\u1d4d3':true,'\u1d4d4':true,'\u1d4d5':true,'\u1d4d6':true,
'\u1d4d7':true,'\u1d4d8':true,'\u1d4d9':true,'\u1d4da':true,
'\u1d4db':true,'\u1d4dc':true,'\u1d4dd':true,'\u1d4de':true,
'\u1d4df':true,'\u1d4e0':true,'\u1d4e1':true,'\u1d4e2':true,
'\u1d4e3':true,'\u1d4e4':true,'\u1d4e5':true,'\u1d4e6':true,
'\u1d4e7':true,'\u1d4e8':true,'\u1d4e9':true,'\u1d504':true,
'\u1d505':true,'\u1d507':true,'\u1d508':true,'\u1d509':true,
'\u1d50a':true,'\u1d50d':true,'\u1d50e':true,'\u1d50f':true,
'\u1d510':true,'\u1d511':true,'\u1d512':true,'\u1d513':true,
'\u1d514':true,'\u1d516':true,'\u1d517':true,'\u1d518':true,
'\u1d519':true,'\u1d51a':true,'\u1d51b':true,'\u1d51c':true,
'\u1d538':true,'\u1d539':true,'\u1d53b':true,'\u1d53c':true,
'\u1d53d':true,'\u1d53e':true,'\u1d540':true,'\u1d541':true,
'\u1d542':true,'\u1d543':true,'\u1d544':true,'\u1d546':true,
'\u1d54a':true,'\u1d54b':true,'\u1d54c':true,'\u1d54d':true,
'\u1d54e':true,'\u1d54f':true,'\u1d550':true,'\u1d56c':true,
'\u1d56d':true,'\u1d56e':true,'\u1d56f':true,'\u1d570':true,
'\u1d571':true,'\u1d572':true,'\u1d573':true,'\u1d574':true,
'\u1d575':true,'\u1d576':true,'\u1d577':true,'\u1d578':true,
'\u1d579':true,'\u1d57a':true,'\u1d57b':true,'\u1d57c':true,
'\u1d57d':true,'\u1d57e':true,'\u1d57f':true,'\u1d580':true,
'\u1d581':true,'\u1d582':true,'\u1d583':true,'\u1d584':true,
'\u1d585':true,'\u1d5a0':true,'\u1d5a1':true,'\u1d5a2':true,
'\u1d5a3':true,'\u1d5a4':true,'\u1d5a5':true,'\u1d5a6':true,
'\u1d5a7':true,'\u1d5a8':true,'\u1d5a9':true,'\u1d5aa':true,
'\u1d5ab':true,'\u1d5ac':true,'\u1d5ad':true,'\u1d5ae':true,
'\u1d5af':true,'\u1d5b0':true,'\u1d5b1':true,'\u1d5b2':true,
'\u1d5b3':true,'\u1d5b4':true,'\u1d5b5':true,'\u1d5b6':true,
'\u1d5b7':true,'\u1d5b8':true,'\u1d5b9':true,'\u1d5d4':true,
'\u1d5d5':true,'\u1d5d6':true,'\u1d5d7':true,'\u1d5d8':true,
'\u1d5d9':true,'\u1d5da':true,'\u1d5db':true,'\u1d5dc':true,
'\u1d5dd':true,'\u1d5de':true,'\u1d5df':true,'\u1d5e0':true,
'\u1d5e1':true,'\u1d5e2':true,'\u1d5e3':true,'\u1d5e4':true,
'\u1d5e5':true,'\u1d5e6':true,'\u1d5e7':true,'\u1d5e8':true,
'\u1d5e9':true,'\u1d5ea':true,'\u1d5eb':true,'\u1d5ec':true,
'\u1d5ed':true,'\u1d608':true,'\u1d609':true,'\u1d60a':true,
'\u1d60b':true,'\u1d60c':true,'\u1d60d':true,'\u1d60e':true,
'\u1d60f':true,'\u1d610':true,'\u1d611':true,'\u1d612':true,
'\u1d613':true,'\u1d614':true,'\u1d615':true,'\u1d616':true,
'\u1d617':true,'\u1d618':true,'\u1d619':true,'\u1d61a':true,
'\u1d61b':true,'\u1d61c':true,'\u1d61d':true,'\u1d61e':true,
'\u1d61f':true,'\u1d620':true,'\u1d621':true,'\u1d63c':true,
'\u1d63d':true,'\u1d63e':true,'\u1d63f':true,'\u1d640':true,
'\u1d641':true,'\u1d642':true,'\u1d643':true,'\u1d644':true,
'\u1d645':true,'\u1d646':true,'\u1d647':true,'\u1d648':true,
'\u1d649':true,'\u1d64a':true,'\u1d64b':true,'\u1d64c':true,
'\u1d64d':true,'\u1d64e':true,'\u1d64f':true,'\u1d650':true,
'\u1d651':true,'\u1d652':true,'\u1d653':true,'\u1d654':true,
'\u1d655':true,'\u1d670':true,'\u1d671':true,'\u1d672':true,
'\u1d673':true,'\u1d674':true,'\u1d675':true,'\u1d676':true,
'\u1d677':true,'\u1d678':true,'\u1d679':true,'\u1d67a':true,
'\u1d67b':true,'\u1d67c':true,'\u1d67d':true,'\u1d67e':true,
'\u1d67f':true,'\u1d680':true,'\u1d681':true,'\u1d682':true,
'\u1d683':true,'\u1d684':true,'\u1d685':true,'\u1d686':true,
'\u1d687':true,'\u1d688':true,'\u1d689':true,'\u1d6a8':true,
'\u1d6a9':true,'\u1d6aa':true,'\u1d6ab':true,'\u1d6ac':true,
'\u1d6ad':true,'\u1d6ae':true,'\u1d6af':true,'\u1d6b0':true,
'\u1d6b1':true,'\u1d6b2':true,'\u1d6b3':true,'\u1d6b4':true,
'\u1d6b5':true,'\u1d6b6':true,'\u1d6b7':true,'\u1d6b8':true,
'\u1d6b9':true,'\u1d6ba':true,'\u1d6bb':true,'\u1d6bc':true,
'\u1d6bd':true,'\u1d6be':true,'\u1d6bf':true,'\u1d6c0':true,
'\u1d6e2':true,'\u1d6e3':true,'\u1d6e4':true,'\u1d6e5':true,
'\u1d6e6':true,'\u1d6e7':true,'\u1d6e8':true,'\u1d6e9':true,
'\u1d6ea':true,'\u1d6eb':true,'\u1d6ec':true,'\u1d6ed':true,
'\u1d6ee':true,'\u1d6ef':true,'\u1d6f0':true,'\u1d6f1':true,
'\u1d6f2':true,'\u1d6f3':true,'\u1d6f4':true,'\u1d6f5':true,
'\u1d6f6':true,'\u1d6f7':true,'\u1d6f8':true,'\u1d6f9':true,
'\u1d6fa':true,'\u1d71c':true,'\u1d71d':true,'\u1d71e':true,
'\u1d71f':true,'\u1d720':true,'\u1d721':true,'\u1d722':true,
'\u1d723':true,'\u1d724':true,'\u1d725':true,'\u1d726':true,
'\u1d727':true,'\u1d728':true,'\u1d729':true,'\u1d72a':true,
'\u1d72b':true,'\u1d72c':true,'\u1d72d':true,'\u1d72e':true,
'\u1d72f':true,'\u1d730':true,'\u1d731':true,'\u1d732':true,
'\u1d733':true,'\u1d734':true,'\u1d756':true,'\u1d757':true,
'\u1d758':true,'\u1d759':true,'\u1d75a':true,'\u1d75b':true,
'\u1d75c':true,'\u1d75d':true,'\u1d75e':true,'\u1d75f':true,
'\u1d760':true,'\u1d761':true,'\u1d762':true,'\u1d763':true,
'\u1d764':true,'\u1d765':true,'\u1d766':true,'\u1d767':true,
'\u1d768':true,'\u1d769':true,'\u1d76a':true,'\u1d76b':true,
'\u1d76c':true,'\u1d76d':true,'\u1d76e':true,'\u1d790':true,
'\u1d791':true,'\u1d792':true,'\u1d793':true,'\u1d794':true,
'\u1d795':true,'\u1d796':true,'\u1d797':true,'\u1d798':true,
'\u1d799':true,'\u1d79a':true,'\u1d79b':true,'\u1d79c':true,
'\u1d79d':true,'\u1d79e':true,'\u1d79f':true,'\u1d7a0':true,
'\u1d7a1':true,'\u1d7a2':true,'\u1d7a3':true,'\u1d7a4':true,
'\u1d7a5':true,'\u1d7a6':true,'\u1d7a7':true,'\u1d7a8':true,
'\u1d7ca':true
      };
  }
)(jQuery);
